!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 174

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(1256)
  integer, parameter :: nGC_9261 = 1
  integer, parameter :: nGC_9263 = 2
  integer, parameter :: nGC_9262 = 3
  integer, parameter :: nGC_9153 = 4
  integer, parameter :: nGC_9155 = 5
  integer, parameter :: nGC_9154 = 6
  integer, parameter :: nGC_131 = 7
  integer, parameter :: nGC_68 = 8
  integer, parameter :: nGC_9121 = 9
  integer, parameter :: nGC_69 = 10
  integer, parameter :: nGC_206 = 11
  integer, parameter :: nGC_9285 = 12
  integer, parameter :: nGC_9101 = 13
  integer, parameter :: nGC_MZ_GF = 14
  integer, parameter :: nGC_9728 = 15
  integer, parameter :: nGC_28 = 16
  integer, parameter :: nGC_9687 = 17
  integer, parameter :: nGC_9686 = 18
  integer, parameter :: nGC_9685 = 19
  integer, parameter :: nGC_22 = 20
  integer, parameter :: nGC_23 = 21
  integer, parameter :: nGC_20 = 22
  integer, parameter :: nGC_21 = 23
  integer, parameter :: nGC_26 = 24
  integer, parameter :: nGC_27 = 25
  integer, parameter :: nGC_24 = 26
  integer, parameter :: nGC_25 = 27
  integer, parameter :: nGC_9279 = 28
  integer, parameter :: nGC_93 = 29
  integer, parameter :: nGC_9276 = 30
  integer, parameter :: nGC_9277 = 31
  integer, parameter :: nGC_9274 = 32
  integer, parameter :: nGC_9109 = 33
  integer, parameter :: nGC_9228 = 34
  integer, parameter :: nGC_GG = 35
  integer, parameter :: nGC_91 = 36
  integer, parameter :: nGC_9074 = 37
  integer, parameter :: nGC_9076 = 38
  integer, parameter :: nGC_9077 = 39
  integer, parameter :: nGC_9070 = 40
  integer, parameter :: nGC_9071 = 41
  integer, parameter :: nGC_9072 = 42
  integer, parameter :: nGC_9294 = 43
  integer, parameter :: nGC_9295 = 44
  integer, parameter :: nGC_9296 = 45
  integer, parameter :: nGC_9297 = 46
  integer, parameter :: nGC_9290 = 47
  integer, parameter :: nGC_9291 = 48
  integer, parameter :: nGC_9293 = 49
  integer, parameter :: nGC_9298 = 50
  integer, parameter :: nGC_9299 = 51
  integer, parameter :: nGC_118 = 52
  integer, parameter :: nGC_9199 = 53
  integer, parameter :: nGC_9196 = 54
  integer, parameter :: nGC_126 = 55
  integer, parameter :: nGC_9750 = 56
  integer, parameter :: nGC_9752 = 57
  integer, parameter :: nGC_122 = 58
  integer, parameter :: nGC_123 = 59
  integer, parameter :: nGC_120 = 60
  integer, parameter :: nGC_121 = 61
  integer, parameter :: nGC_9207 = 62
  integer, parameter :: nGC_1584 = 63
  integer, parameter :: nGC_9204 = 64
  integer, parameter :: nGC_128 = 65
  integer, parameter :: nGC_129 = 66
  integer, parameter :: nGC_100 = 67
  integer, parameter :: nGC_14125 = 68
  integer, parameter :: nGC_MMW_GF = 69
  integer, parameter :: nGC_1566 = 70
  integer, parameter :: nGC_1564 = 71
  integer, parameter :: nGC_1562 = 72
  integer, parameter :: nGC_77 = 73
  integer, parameter :: nGC_9100 = 74
  integer, parameter :: nGC_9108 = 75
  integer, parameter :: nGC_97 = 76
  integer, parameter :: nGC_GGH = 77
  integer, parameter :: nGC_141 = 78
  integer, parameter :: nGC_I = 79
  integer, parameter :: nGC_109 = 80
  integer, parameter :: nGC_MW_GF = 81
  integer, parameter :: nGC_9751 = 82
  integer, parameter :: nGC_9763 = 83
  integer, parameter :: nGC_3 = 84
  integer, parameter :: nGC_2 = 85
  integer, parameter :: nGC_1 = 86
  integer, parameter :: nGC_7 = 87
  integer, parameter :: nGC_6 = 88
  integer, parameter :: nGC_5 = 89
  integer, parameter :: nGC_4 = 90
  integer, parameter :: nGC_9 = 91
  integer, parameter :: nGC_8 = 92
  integer, parameter :: nGC_HHGG = 93
  integer, parameter :: nGC_48 = 94
  integer, parameter :: nGC_49 = 95
  integer, parameter :: nGC_MI = 96
  integer, parameter :: nGC_53 = 97
  integer, parameter :: nGC_52 = 98
  integer, parameter :: nGC_51 = 99
  integer, parameter :: nGC_50 = 100
  integer, parameter :: nGC_57 = 101
  integer, parameter :: nGC_56 = 102
  integer, parameter :: nGC_55 = 103
  integer, parameter :: nGC_54 = 104
  integer, parameter :: nGC_59 = 105
  integer, parameter :: nGC_58 = 106
  integer, parameter :: nGC_46 = 107
  integer, parameter :: nGC_2546 = 108
  integer, parameter :: nGC_9241 = 109
  integer, parameter :: nGC_9247 = 110
  integer, parameter :: nGC_9712 = 111
  integer, parameter :: nGC_17544 = 112
  integer, parameter :: nGC_9081 = 113
  integer, parameter :: nGC_9082 = 114
  integer, parameter :: nGC_17549 = 115
  integer, parameter :: nGC_9250 = 116
  integer, parameter :: nGC_9190 = 117
  integer, parameter :: nGC_107 = 118
  integer, parameter :: nGC_9195 = 119
  integer, parameter :: nGC_108 = 120
  integer, parameter :: nGC_15695 = 121
  integer, parameter :: nGC_9253 = 122
  integer, parameter :: nGC_19 = 123
  integer, parameter :: nGC_9220 = 124
  integer, parameter :: nGC_9706 = 125
  integer, parameter :: nGC_654 = 126
  integer, parameter :: nGC_18 = 127
  integer, parameter :: nGC_9757 = 128
  integer, parameter :: nGC_1570 = 129
  integer, parameter :: nGC_9705 = 130
  integer, parameter :: nGC_9661 = 131
  integer, parameter :: nGC_9663 = 132
  integer, parameter :: nGC_9662 = 133
  integer, parameter :: nGC_9665 = 134
  integer, parameter :: nGC_9667 = 135
  integer, parameter :: nGC_17550 = 136
  integer, parameter :: nGC_15333 = 137
  integer, parameter :: nGC_9668 = 138
  integer, parameter :: nGC_9142 = 139
  integer, parameter :: nGC_15330 = 140
  integer, parameter :: nGC_14139 = 141
  integer, parameter :: nGC_127 = 142
  integer, parameter :: nGC_9759 = 143
  integer, parameter :: nGC_9159 = 144
  integer, parameter :: nGC_9318 = 145
  integer, parameter :: nGC_95 = 146
  integer, parameter :: nGC_MT = 147
  integer, parameter :: nGC_9758 = 148
  integer, parameter :: nGC_9158 = 149
  integer, parameter :: nGC_9447 = 150
  integer, parameter :: nGC_9443 = 151
  integer, parameter :: nGC_506 = 152
  integer, parameter :: nGC_9099 = 153
  integer, parameter :: nGC_14874 = 154
  integer, parameter :: nGC_9314 = 155
  integer, parameter :: nGC_MZ = 156
  integer, parameter :: nGC_17 = 157
  integer, parameter :: nGC_16 = 158
  integer, parameter :: nGC_15 = 159
  integer, parameter :: nGC_14 = 160
  integer, parameter :: nGC_13 = 161
  integer, parameter :: nGC_12 = 162
  integer, parameter :: nGC_11 = 163
  integer, parameter :: nGC_10 = 164
  integer, parameter :: nGC_15997 = 165
  integer, parameter :: nGC_15996 = 166
  integer, parameter :: nGC_15991 = 167
  integer, parameter :: nGC_15990 = 168
  integer, parameter :: nGC_9696 = 169
  integer, parameter :: nGC_9697 = 170
  integer, parameter :: nGC_14873 = 171
  integer, parameter :: nGC_15790 = 172
  integer, parameter :: nGC_9366 = 173
  integer, parameter :: nGC_14878 = 174
  integer, parameter :: nGC_15157 = 175
  integer, parameter :: nGC_15096 = 176
  integer, parameter :: nGC_15097 = 177
  integer, parameter :: nGC_15095 = 178
  integer, parameter :: nGC_14578 = 179
  integer, parameter :: nGC_14579 = 180
  integer, parameter :: nGC_9363 = 181
  integer, parameter :: nGC_96 = 182
  integer, parameter :: nGC_15158 = 183
  integer, parameter :: nGC_14174 = 184
  integer, parameter :: nGC_9184 = 185
  integer, parameter :: nGC_9180 = 186
  integer, parameter :: nGC_135 = 187
  integer, parameter :: nGC_134 = 188
  integer, parameter :: nGC_137 = 189
  integer, parameter :: nGC_136 = 190
  integer, parameter :: nGC_480 = 191
  integer, parameter :: nGC_15094 = 192
  integer, parameter :: nGC_9748 = 193
  integer, parameter :: nGC_9749 = 194
  integer, parameter :: nGC_9214 = 195
  integer, parameter :: nGC_9215 = 196
  integer, parameter :: nGC_138 = 197
  integer, parameter :: nGC_9741 = 198
  integer, parameter :: nGC_17192 = 199
  integer, parameter :: nGC_94 = 200
  integer, parameter :: nGC_1514 = 201
  integer, parameter :: nGC_9370 = 202
  integer, parameter :: nGC_9702 = 203
  integer, parameter :: nGC_18817 = 204
  integer, parameter :: nGC_18818 = 205
  integer, parameter :: nGC_16909 = 206
  integer, parameter :: nGC_1596 = 207
  integer, parameter :: nGC_14203 = 208
  integer, parameter :: nGC_17194 = 209
  integer, parameter :: nGC_9157 = 210
  integer, parameter :: nGC_92 = 211
  integer, parameter :: nGC_HHHH = 212
  integer, parameter :: nGC_9156 = 213
  integer, parameter :: nGC_1572 = 214
  integer, parameter :: nGC_9415 = 215
  integer, parameter :: nGC_13971 = 216
  integer, parameter :: nGC_9141 = 217
  integer, parameter :: nGC_15051 = 218
  integer, parameter :: nGC_9765 = 219
  integer, parameter :: nGC_9116 = 220
  integer, parameter :: nGC_574 = 221
  integer, parameter :: nGC_13958 = 222
  integer, parameter :: nGC_MB = 223
  integer, parameter :: nGC_9381 = 224
  integer, parameter :: nGC_14171 = 225
  integer, parameter :: nGC_44 = 226
  integer, parameter :: nGC_45 = 227
  integer, parameter :: nGC_47 = 228
  integer, parameter :: nGC_40 = 229
  integer, parameter :: nGC_41 = 230
  integer, parameter :: nGC_42 = 231
  integer, parameter :: nGC_43 = 232
  integer, parameter :: nGC_9703 = 233
  integer, parameter :: nGC_9252 = 234
  integer, parameter :: nGC_9254 = 235
  integer, parameter :: nGC_14630 = 236
  integer, parameter :: nGC_9256 = 237
  integer, parameter :: nGC_9257 = 238
  integer, parameter :: nGC_9258 = 239
  integer, parameter :: nGC_9259 = 240
  integer, parameter :: nGC_14736 = 241
  integer, parameter :: nGC_14737 = 242
  integer, parameter :: nGC_9673 = 243
  integer, parameter :: nGC_9092 = 244
  integer, parameter :: nGC_9093 = 245
  integer, parameter :: nGC_9090 = 246
  integer, parameter :: nGC_9091 = 247
  integer, parameter :: nGC_15605 = 248
  integer, parameter :: nGC_9095 = 249
  integer, parameter :: nGC_9311 = 250
  integer, parameter :: nGC_9310 = 251
  integer, parameter :: nGC_9313 = 252
  integer, parameter :: nGC_9312 = 253
  integer, parameter :: nGC_9315 = 254
  integer, parameter :: nGC_174 = 255
  integer, parameter :: nGC_9317 = 256
  integer, parameter :: nGC_9316 = 257
  integer, parameter :: nGC_9183 = 258
  integer, parameter :: nGC_9171 = 259
  integer, parameter :: nGC_9170 = 260
  integer, parameter :: nGC_9173 = 261
  integer, parameter :: nGC_9172 = 262
  integer, parameter :: nGC_9179 = 263
  integer, parameter :: nGC_9178 = 264
  integer, parameter :: nGC_14126 = 265
  integer, parameter :: nGC_20004 = 266
  integer, parameter :: nGC_9674 = 267
  integer, parameter :: nGC_9672 = 268
  integer, parameter :: nGC_14872 = 269
  integer, parameter :: nGC_9670 = 270
  integer, parameter :: nGC_130 = 271
  integer, parameter :: nGC_9243 = 272
  integer, parameter :: nGC_14303 = 273
  integer, parameter :: nGC_133 = 274
  integer, parameter :: nGC_16846 = 275
  integer, parameter :: nGC_9242 = 276
  integer, parameter :: nGC_16849 = 277
  integer, parameter :: nGC_132 = 278
  integer, parameter :: nGC_9717 = 279
  integer, parameter :: nGC_9746 = 280
  integer, parameter :: nGC_9708 = 281
  integer, parameter :: nGC_14998 = 282
  integer, parameter :: nGC_14999 = 283
  integer, parameter :: nGC_14871 = 284
  integer, parameter :: nGC_9216 = 285
  integer, parameter :: nGC_9246 = 286
  integer, parameter :: nGC_9474 = 287
  integer, parameter :: nGC_9217 = 288
  integer, parameter :: nGC_9245 = 289
  integer, parameter :: nGC_9210 = 290
  integer, parameter :: nGC_9244 = 291
  integer, parameter :: nGC_29 = 292
  integer, parameter :: nGC_14393 = 293
  integer, parameter :: nGC_GPGMGPGM = 294
  integer, parameter :: nGC_9189 = 295
  integer, parameter :: nGC_14541 = 296
  integer, parameter :: nGC_14540 = 297
  integer, parameter :: nGC_9249 = 298
  integer, parameter :: nGC_9248 = 299
  integer, parameter :: nGC_9211 = 300
  integer, parameter :: nGC_16026 = 301
  integer, parameter :: nGC_14997 = 302
  integer, parameter :: nGC_14877 = 303
  integer, parameter :: nGC_16028 = 304
  integer, parameter :: nGC_146 = 305
  integer, parameter :: nGC_14264 = 306
  integer, parameter :: nGC_9083 = 307
  integer, parameter :: nGC_9143 = 308
  integer, parameter :: nGC_9372 = 309
  integer, parameter :: nGC_9278 = 310
  integer, parameter :: nGC_150 = 311
  integer, parameter :: nGC_17164 = 312
  integer, parameter :: nGC_17161 = 313
  integer, parameter :: nGC_9357 = 314
  integer, parameter :: nGC_9588 = 315
  integer, parameter :: nGC_140 = 316
  integer, parameter :: nGC_9322 = 317
  integer, parameter :: nGC_99 = 318
  integer, parameter :: nGC_98 = 319
  integer, parameter :: nGC_15310 = 320
  integer, parameter :: nGC_9587 = 321
  integer, parameter :: nGC_1160 = 322
  integer, parameter :: nGC_746 = 323
  integer, parameter :: nGC_75 = 324
  integer, parameter :: nGC_74 = 325
  integer, parameter :: nGC_76 = 326
  integer, parameter :: nGC_71 = 327
  integer, parameter :: nGC_70 = 328
  integer, parameter :: nGC_73 = 329
  integer, parameter :: nGC_72 = 330
  integer, parameter :: nGC_90 = 331
  integer, parameter :: nGC_9212 = 332
  integer, parameter :: nGC_9275 = 333
  integer, parameter :: nGC_78 = 334
  integer, parameter :: nGC_9255 = 335
  integer, parameter :: nGC_9632 = 336
  integer, parameter :: nGC_9630 = 337
  integer, parameter :: nGC_79 = 338
  integer, parameter :: nGC_9636 = 339
  integer, parameter :: nGC_9637 = 340
  integer, parameter :: nGC_117 = 341
  integer, parameter :: nGC_9229 = 342
  integer, parameter :: nGC_101 = 343
  integer, parameter :: nGC_102 = 344
  integer, parameter :: nGC_103 = 345
  integer, parameter :: nGC_104 = 346
  integer, parameter :: nGC_105 = 347
  integer, parameter :: nGC_106 = 348
  integer, parameter :: nGC_9221 = 349
  integer, parameter :: nGC_9223 = 350
  integer, parameter :: nGC_9222 = 351
  integer, parameter :: nGC_9737 = 352
  integer, parameter :: nGC_9736 = 353
  integer, parameter :: nGC_9227 = 354
  integer, parameter :: nGC_9734 = 355
  integer, parameter :: nGC_9152 = 356
  integer, parameter :: nGC_9704 = 357
  integer, parameter :: nGC_18821 = 358
  integer, parameter :: nGC_18822 = 359
  integer, parameter :: nGC_652 = 360
  integer, parameter :: nGC_14802 = 361
  integer, parameter :: nGC_9645 = 362
  integer, parameter :: nGC_9642 = 363
  integer, parameter :: nGC_9641 = 364
  integer, parameter :: nGC_9640 = 365
  integer, parameter :: nGC_89 = 366
  integer, parameter :: nGC_9124 = 367
  integer, parameter :: nGC_9073 = 368
  integer, parameter :: nGC_9122 = 369
  integer, parameter :: nGC_9123 = 370
  integer, parameter :: nGC_9648 = 371
  integer, parameter :: nGC_14330 = 372
  integer, parameter :: nGC_14331 = 373
  integer, parameter :: nGC_14332 = 374
  integer, parameter :: nGC_3142 = 375
  integer, parameter :: nGC_3140 = 376
  integer, parameter :: nGC_16781 = 377
  integer, parameter :: nGC_16780 = 378
  integer, parameter :: nGC_9292 = 379
  integer, parameter :: nGC_16785 = 380
  integer, parameter :: nGC_16784 = 381
  integer, parameter :: nGC_214 = 382
  integer, parameter :: nGC_16023 = 383
  integer, parameter :: nGC_210 = 384
  integer, parameter :: nGC_16027 = 385
  integer, parameter :: nGC_16024 = 386
  integer, parameter :: nGC_16025 = 387
  integer, parameter :: nGC_9213 = 388
  integer, parameter :: nGC_149 = 389
  integer, parameter :: nGC_9629 = 390
  integer, parameter :: nGC_14265 = 391
  integer, parameter :: nGC_HHH = 392
  integer, parameter :: nGC_14807 = 393
  integer, parameter :: nGC_9465 = 394
  integer, parameter :: nGC_922 = 395
  integer, parameter :: nGC_148 = 396
  integer, parameter :: nGC_9549 = 397
  integer, parameter :: nGC_9546 = 398
  integer, parameter :: nGC_9543 = 399
  integer, parameter :: nGC_9305 = 400
  integer, parameter :: nGC_119 = 401
  integer, parameter :: nGC_9120 = 402
  integer, parameter :: nGC_14306 = 403
  integer, parameter :: nGC_9208 = 404
  integer, parameter :: nGC_14788 = 405
  integer, parameter :: nGC_9753 = 406
  integer, parameter :: nGC_17543 = 407
  integer, parameter :: nGC_9541 = 408
  integer, parameter :: nGC_39 = 409
  integer, parameter :: nGC_38 = 410
  integer, parameter :: nGC_31 = 411
  integer, parameter :: nGC_30 = 412
  integer, parameter :: nGC_33 = 413
  integer, parameter :: nGC_32 = 414
  integer, parameter :: nGC_35 = 415
  integer, parameter :: nGC_37 = 416
  integer, parameter :: nGC_36 = 417
  integer, parameter :: nGC_144 = 418
  integer, parameter :: nGC_14136 = 419
  integer, parameter :: nGC_9304 = 420
  integer, parameter :: nGC_147 = 421
  integer, parameter :: nGC_9269 = 422
  integer, parameter :: nGC_9268 = 423
  integer, parameter :: nGC_9300 = 424
  integer, parameter :: nGC_9301 = 425
  integer, parameter :: nGC_9265 = 426
  integer, parameter :: nGC_9264 = 427
  integer, parameter :: nGC_9267 = 428
  integer, parameter :: nGC_9266 = 429
  integer, parameter :: nGC_17521 = 430
  integer, parameter :: nGC_9309 = 431
  integer, parameter :: nGC_15331 = 432
  integer, parameter :: nGC_9307 = 433
  integer, parameter :: nGC_9069 = 434
  integer, parameter :: nGC_9068 = 435
  integer, parameter :: nGC_9067 = 436
  integer, parameter :: nGC_9066 = 437
  integer, parameter :: nGC_9075 = 438
  integer, parameter :: nGC_9206 = 439
  integer, parameter :: nGC_9664 = 440
  integer, parameter :: nGC_9287 = 441
  integer, parameter :: nGC_9286 = 442
  integer, parameter :: nGC_9284 = 443
  integer, parameter :: nGC_9283 = 444
  integer, parameter :: nGC_14724 = 445
  integer, parameter :: nGC_15419 = 446
  integer, parameter :: nGC_15414 = 447
  integer, parameter :: nGC_9666 = 448
  integer, parameter :: nGC_9289 = 449
  integer, parameter :: nGC_9288 = 450
  integer, parameter :: nGC_9669 = 451
  integer, parameter :: nGC_115 = 452
  integer, parameter :: nGC_15332 = 453
  integer, parameter :: nGC_16210 = 454
  integer, parameter :: nGC_9162 = 455
  integer, parameter :: nGC_9163 = 456
  integer, parameter :: nGC_9160 = 457
  integer, parameter :: nGC_9161 = 458
  integer, parameter :: nGC_9164 = 459
  integer, parameter :: nGC_67 = 460
  integer, parameter :: nGC_9198 = 461
  integer, parameter :: nGC_14099 = 462
  integer, parameter :: nGC_9764 = 463
  integer, parameter :: nGC_9197 = 464
  integer, parameter :: nGC_9766 = 465
  integer, parameter :: nGC_9760 = 466
  integer, parameter :: nGC_9761 = 467
  integer, parameter :: nGC_9762 = 468
  integer, parameter :: nGC_16852 = 469
  integer, parameter :: nGC_MH = 470
  integer, parameter :: nGC_MM = 471
  integer, parameter :: nGC_MC = 472
  integer, parameter :: nGC_14143 = 473
  integer, parameter :: nGC_61 = 474
  integer, parameter :: nGC_14076 = 475
  integer, parameter :: nGC_ME = 476
  integer, parameter :: nGC_MD = 477
  integer, parameter :: nGC_19748 = 478
  integer, parameter :: nGC_14985 = 479
  integer, parameter :: nGC_MS = 480
  integer, parameter :: nGC_17215 = 481
  integer, parameter :: nGC_MW = 482
  integer, parameter :: nGC_9094 = 483
  integer, parameter :: nGC_MU = 484
  integer, parameter :: nGC_19745 = 485
  integer, parameter :: nGC_9618 = 486
  integer, parameter :: nGC_124 = 487
  integer, parameter :: nGC_145 = 488
  integer, parameter :: nGC_9115 = 489
  integer, parameter :: nGC_125 = 490
  integer, parameter :: nGC_9202 = 491
  integer, parameter :: nGC_9110 = 492
  integer, parameter :: nGC_63 = 493
  integer, parameter :: nGC_13968 = 494
  integer, parameter :: nGC_9623 = 495
  integer, parameter :: nGC_9754 = 496
  integer, parameter :: nGC_9209 = 497
  integer, parameter :: nGC_14202 = 498
  integer, parameter :: nGC_9756 = 499
  integer, parameter :: nGC_14204 = 500
  integer, parameter :: nGC_14205 = 501
  integer, parameter :: nGC_14206 = 502
  integer, parameter :: nGC_14207 = 503
  integer, parameter :: nGC_9205 = 504
  integer, parameter :: nGC_9308 = 505
  integer, parameter :: nGC_15000 = 506
  integer, parameter :: nGC_14087 = 507
  integer, parameter :: nGC_9203 = 508
  integer, parameter :: nGC_14805 = 509
  integer, parameter :: nGC_14933 = 510
  integer, parameter :: nGC_9200 = 511
  integer, parameter :: nGC_9114 = 512
  integer, parameter :: nGC_9767 = 513
  integer, parameter :: nGC_34 = 514
  integer, parameter :: nGC_9201 = 515
  integer, parameter :: nGC_9617 = 516
  integer, parameter :: nGC_14787 = 517
  integer, parameter :: nGC_112 = 518
  integer, parameter :: nGC_MTA = 519
  integer, parameter :: nGC_14851 = 520
  integer, parameter :: nGC_14854 = 521
  integer, parameter :: nGC_9260 = 522
  integer, parameter :: nGC_9240 = 523
  integer, parameter :: nGC_9439 = 524
  integer, parameter :: nGC_9729 = 525
  integer, parameter :: nGC_88 = 526
  integer, parameter :: nGC_139 = 527
  integer, parameter :: nGC_15072 = 528
  integer, parameter :: nGC_17520 = 529
  integer, parameter :: nGC_9755 = 530
  integer, parameter :: nGC_9338 = 531
  integer, parameter :: nGC_80 = 532
  integer, parameter :: nGC_81 = 533
  integer, parameter :: nGC_82 = 534
  integer, parameter :: nGC_83 = 535
  integer, parameter :: nGC_84 = 536
  integer, parameter :: nGC_85 = 537
  integer, parameter :: nGC_86 = 538
  integer, parameter :: nGC_87 = 539
  integer, parameter :: nGC_9306 = 540
  integer, parameter :: nGC_14808 = 541
  integer, parameter :: nGC_9251 = 542
  integer, parameter :: nGC_111 = 543
  integer, parameter :: nGC_9364 = 544
  integer, parameter :: nGC_9671 = 545
  integer, parameter :: nGC_66 = 546
  integer, parameter :: nGC_64 = 547
  integer, parameter :: nGC_65 = 548
  integer, parameter :: nGC_62 = 549
  integer, parameter :: nGC_60 = 550
  integer, parameter :: nGC_116 = 551
  integer, parameter :: nGC_20005 = 552
  integer, parameter :: nGC_9302 = 553
  integer, parameter :: nGC_1752 = 554
  integer, parameter :: nGC_9303 = 555
  integer, parameter :: nGC_9237 = 556
  integer, parameter :: nGC_114 = 557
  integer, parameter :: nGC_142 = 558
  integer, parameter :: nGC_9230 = 559
  integer, parameter :: nGC_110 = 560
  integer, parameter :: nGC_113 = 561
  integer, parameter :: nGC_143 = 562
  integer, parameter :: nGC_9238 = 563
  integer, parameter :: nGC_9239 = 564
  integer, parameter :: nGC_14756 = 565
  integer, parameter :: nGC_9480 = 566
  integer, parameter :: nGC_9483 = 567
  integer, parameter :: nGC_9484 = 568
  integer, parameter :: nGC_9339 = 569
  integer, parameter :: nGC_9337 = 570
  integer, parameter :: nGC_9336 = 571
  integer, parameter :: nGC_9335 = 572
  integer, parameter :: nGC_9334 = 573
  integer, parameter :: nGC_9333 = 574
  integer, parameter :: nGC_9332 = 575
  integer, parameter :: nGC_9331 = 576
  integer, parameter :: nGC_9330 = 577
  integer, parameter :: nGC_14035 = 578
  integer, parameter :: nGC_14034 = 579
  integer, parameter :: nGC_14033 = 580
  integer, parameter :: nGC_14030 = 581
  integer, parameter :: nGC_14538 = 582
  integer, parameter :: nGC_14539 = 583
  integer, parameter :: nGC_16224 = 584
  integer, parameter :: nGC_16225 = 585
  integer, parameter :: nGC_14559 = 586
  integer, parameter :: nGC_9654 = 587
  integer, parameter :: nGC_9655 = 588
  integer, parameter :: nGC_9656 = 589
  integer, parameter :: nGC_9657 = 590
  integer, parameter :: nGC_9650 = 591
  integer, parameter :: nGC_9651 = 592
  integer, parameter :: nGC_9652 = 593
  integer, parameter :: nGC_9653 = 594
  integer, parameter :: nGC_13983 = 595
  integer, parameter :: nGC_9658 = 596
  integer, parameter :: nGC_9659 = 597
  integer, parameter :: nGC_14329 = 598
  integer, parameter :: nGC_14248 = 599
  integer, parameter :: nGC_16030 = 600
  integer, parameter :: nGC_9427 = 601
  integer, parameter :: nGC_16819 = 602
  integer, parameter :: nGC_9426 = 603
  integer, parameter :: nGC_9356 = 604
  integer, parameter :: nGC_9411 = 605
  integer, parameter :: nGC_9470 = 606
  integer, parameter :: nGC_17033 = 607
  integer, parameter :: nGC_9472 = 608
  integer, parameter :: nGC_17031 = 609
  integer, parameter :: nGC_17034 = 610
  integer, parameter :: nGC_9477 = 611
  integer, parameter :: nGC_9478 = 612
  integer, parameter :: nGC_9352 = 613
  integer, parameter :: nGC_374 = 614
  integer, parameter :: nGC_9571 = 615
  integer, parameter :: nGC_9570 = 616
  integer, parameter :: nGC_470 = 617
  integer, parameter :: nGC_472 = 618
  integer, parameter :: nGC_9683 = 619
  integer, parameter :: nGC_9682 = 620
  integer, parameter :: nGC_9681 = 621
  integer, parameter :: nGC_16223 = 622
  integer, parameter :: nGC_9684 = 623
  integer, parameter :: nGC_9689 = 624
  integer, parameter :: nGC_9688 = 625
  integer, parameter :: nGC_14713 = 626
  integer, parameter :: nGC_9371 = 627
  integer, parameter :: nGC_9377 = 628
  integer, parameter :: nGC_15787 = 629
  integer, parameter :: nGC_9375 = 630
  integer, parameter :: nGC_9374 = 631
  integer, parameter :: nGC_9378 = 632
  integer, parameter :: nGC_17026 = 633
  integer, parameter :: nGC_16342 = 634
  integer, parameter :: nGC_14102 = 635
  integer, parameter :: nGC_14145 = 636
  integer, parameter :: nGC_14144 = 637
  integer, parameter :: nGC_17216 = 638
  integer, parameter :: nGC_14140 = 639
  integer, parameter :: nGC_9619 = 640
  integer, parameter :: nGC_17193 = 641
  integer, parameter :: nGC_17195 = 642
  integer, parameter :: nGC_9610 = 643
  integer, parameter :: nGC_14784 = 644
  integer, parameter :: nGC_9616 = 645
  integer, parameter :: nGC_14106 = 646
  integer, parameter :: nGC_21825 = 647
  integer, parameter :: nGC_1446 = 648
  integer, parameter :: nGC_14360 = 649
  integer, parameter :: nGC_14040 = 650
  integer, parameter :: nGC_16917 = 651
  integer, parameter :: nGC_17366 = 652
  integer, parameter :: nGC_16918 = 653
  integer, parameter :: nGC_16919 = 654
  integer, parameter :: nGC_17363 = 655
  integer, parameter :: nGC_14215 = 656
  integer, parameter :: nGC_9539 = 657
  integer, parameter :: nGC_9538 = 658
  integer, parameter :: nGC_9534 = 659
  integer, parameter :: nGC_9537 = 660
  integer, parameter :: nGC_9536 = 661
  integer, parameter :: nGC_9531 = 662
  integer, parameter :: nGC_1048 = 663
  integer, parameter :: nGC_9602 = 664
  integer, parameter :: nGC_9409 = 665
  integer, parameter :: nGC_9408 = 666
  integer, parameter :: nGC_9401 = 667
  integer, parameter :: nGC_9403 = 668
  integer, parameter :: nGC_9402 = 669
  integer, parameter :: nGC_9404 = 670
  integer, parameter :: nGC_9407 = 671
  integer, parameter :: nGC_9406 = 672
  integer, parameter :: nGC_9605 = 673
  integer, parameter :: nGC_15725 = 674
  integer, parameter :: nGC_9393 = 675
  integer, parameter :: nGC_9392 = 676
  integer, parameter :: nGC_9395 = 677
  integer, parameter :: nGC_9394 = 678
  integer, parameter :: nGC_9396 = 679
  integer, parameter :: nGC_9715 = 680
  integer, parameter :: nGC_9714 = 681
  integer, parameter :: nGC_9716 = 682
  integer, parameter :: nGC_9711 = 683
  integer, parameter :: nGC_9710 = 684
  integer, parameter :: nGC_9713 = 685
  integer, parameter :: nGC_14741 = 686
  integer, parameter :: nGC_14742 = 687
  integer, parameter :: nGC_9719 = 688
  integer, parameter :: nGC_9718 = 689
  integer, parameter :: nGC_17546 = 690
  integer, parameter :: nGC_17545 = 691
  integer, parameter :: nGC_2148 = 692
  integer, parameter :: nGC_9497 = 693
  integer, parameter :: nGC_9494 = 694
  integer, parameter :: nGC_9492 = 695
  integer, parameter :: nGC_9493 = 696
  integer, parameter :: nGC_9490 = 697
  integer, parameter :: nGC_9491 = 698
  integer, parameter :: nGC_14483 = 699
  integer, parameter :: nGC_14489 = 700
  integer, parameter :: nGC_9660 = 701
  integer, parameter :: nGC_13990 = 702
  integer, parameter :: nGC_15334 = 703
  integer, parameter :: nGC_14257 = 704
  integer, parameter :: nGC_17552 = 705
  integer, parameter :: nGC_14311 = 706
  integer, parameter :: nGC_16820 = 707
  integer, parameter :: nGC_9615 = 708
  integer, parameter :: nGC_14419 = 709
  integer, parameter :: nGC_14418 = 710
  integer, parameter :: nGC_14004 = 711
  integer, parameter :: nGC_398 = 712
  integer, parameter :: nGC_394 = 713
  integer, parameter :: nGC_9566 = 714
  integer, parameter :: nGC_9565 = 715
  integer, parameter :: nGC_9560 = 716
  integer, parameter :: nGC_9445 = 717
  integer, parameter :: nGC_9444 = 718
  integer, parameter :: nGC_9446 = 719
  integer, parameter :: nGC_9441 = 720
  integer, parameter :: nGC_9440 = 721
  integer, parameter :: nGC_9569 = 722
  integer, parameter :: nGC_308 = 723
  integer, parameter :: nGC_16753 = 724
  integer, parameter :: nGC_15993 = 725
  integer, parameter :: nGC_15992 = 726
  integer, parameter :: nGC_9690 = 727
  integer, parameter :: nGC_9691 = 728
  integer, parameter :: nGC_9692 = 729
  integer, parameter :: nGC_9693 = 730
  integer, parameter :: nGC_9694 = 731
  integer, parameter :: nGC_9695 = 732
  integer, parameter :: nGC_9698 = 733
  integer, parameter :: nGC_9699 = 734
  integer, parameter :: nGC_9360 = 735
  integer, parameter :: nGC_9361 = 736
  integer, parameter :: nGC_9362 = 737
  integer, parameter :: nGC_14706 = 738
  integer, parameter :: nGC_9365 = 739
  integer, parameter :: nGC_9367 = 740
  integer, parameter :: nGC_9368 = 741
  integer, parameter :: nGC_9369 = 742
  integer, parameter :: nGC_14879 = 743
  integer, parameter :: nGC_15098 = 744
  integer, parameter :: nGC_15099 = 745
  integer, parameter :: nGC_9593 = 746
  integer, parameter :: nGC_9592 = 747
  integer, parameter :: nGC_9591 = 748
  integer, parameter :: nGC_9590 = 749
  integer, parameter :: nGC_9625 = 750
  integer, parameter :: nGC_9624 = 751
  integer, parameter :: nGC_9627 = 752
  integer, parameter :: nGC_9626 = 753
  integer, parameter :: nGC_9621 = 754
  integer, parameter :: nGC_9620 = 755
  integer, parameter :: nGC_9471 = 756
  integer, parameter :: nGC_14178 = 757
  integer, parameter :: nGC_14179 = 758
  integer, parameter :: nGC_9628 = 759
  integer, parameter :: nGC_9473 = 760
  integer, parameter :: nGC_14777 = 761
  integer, parameter :: nGC_14778 = 762
  integer, parameter :: nGC_14779 = 763
  integer, parameter :: nGC_9744 = 764
  integer, parameter :: nGC_9742 = 765
  integer, parameter :: nGC_9743 = 766
  integer, parameter :: nGC_9740 = 767
  integer, parameter :: nGC_9475 = 768
  integer, parameter :: nGC_14050 = 769
  integer, parameter :: nGC_14053 = 770
  integer, parameter :: nGC_14057 = 771
  integer, parameter :: nGC_14194 = 772
  integer, parameter :: nGC_14110 = 773
  integer, parameter :: nGC_16014 = 774
  integer, parameter :: nGC_9646 = 775
  integer, parameter :: nGC_14510 = 776
  integer, parameter :: nGC_18819 = 777
  integer, parameter :: nGC_16207 = 778
  integer, parameter :: nGC_9528 = 779
  integer, parameter :: nGC_9529 = 780
  integer, parameter :: nGC_9522 = 781
  integer, parameter :: nGC_9609 = 782
  integer, parameter :: nGC_9520 = 783
  integer, parameter :: nGC_9521 = 784
  integer, parameter :: nGC_9526 = 785
  integer, parameter :: nGC_9527 = 786
  integer, parameter :: nGC_21778 = 787
  integer, parameter :: nGC_14358 = 788
  integer, parameter :: nGC_14290 = 789
  integer, parameter :: nGC_14420 = 790
  integer, parameter :: nGC_14421 = 791
  integer, parameter :: nGC_9622 = 792
  integer, parameter :: nGC_14357 = 793
  integer, parameter :: nGC_9575 = 794
  integer, parameter :: nGC_9416 = 795
  integer, parameter :: nGC_9417 = 796
  integer, parameter :: nGC_9414 = 797
  integer, parameter :: nGC_9412 = 798
  integer, parameter :: nGC_9413 = 799
  integer, parameter :: nGC_19518 = 800
  integer, parameter :: nGC_9418 = 801
  integer, parameter :: nGC_9419 = 802
  integer, parameter :: nGC_9559 = 803
  integer, parameter :: nGC_9558 = 804
  integer, parameter :: nGC_9557 = 805
  integer, parameter :: nGC_9556 = 806
  integer, parameter :: nGC_9555 = 807
  integer, parameter :: nGC_9554 = 808
  integer, parameter :: nGC_15057 = 809
  integer, parameter :: nGC_15054 = 810
  integer, parameter :: nGC_15058 = 811
  integer, parameter :: nGC_9388 = 812
  integer, parameter :: nGC_9389 = 813
  integer, parameter :: nGC_9386 = 814
  integer, parameter :: nGC_9387 = 815
  integer, parameter :: nGC_9384 = 816
  integer, parameter :: nGC_9385 = 817
  integer, parameter :: nGC_9382 = 818
  integer, parameter :: nGC_9383 = 819
  integer, parameter :: nGC_674 = 820
  integer, parameter :: nGC_15808 = 821
  integer, parameter :: nGC_15805 = 822
  integer, parameter :: nGC_15335 = 823
  integer, parameter :: nGC_9700 = 824
  integer, parameter :: nGC_9701 = 825
  integer, parameter :: nGC_9707 = 826
  integer, parameter :: nGC_14633 = 827
  integer, parameter :: nGC_17551 = 828
  integer, parameter :: nGC_14880 = 829
  integer, parameter :: nGC_9709 = 830
  integer, parameter :: nGC_1832 = 831
  integer, parameter :: nGC_15606 = 832
  integer, parameter :: nGC_15422 = 833
  integer, parameter :: nGC_15421 = 834
  integer, parameter :: nGC_248 = 835
  integer, parameter :: nGC_14128 = 836
  integer, parameter :: nGC_14084 = 837
  integer, parameter :: nGC_14088 = 838
  integer, parameter :: nGC_14089 = 839
  integer, parameter :: nGC_14127 = 840
  integer, parameter :: nGC_13963 = 841
  integer, parameter :: nGC_9678 = 842
  integer, parameter :: nGC_9679 = 843
  integer, parameter :: nGC_9676 = 844
  integer, parameter :: nGC_9677 = 845
  integer, parameter :: nGC_9675 = 846
  integer, parameter :: nGC_14069 = 847
  integer, parameter :: nGC_14302 = 848
  integer, parameter :: nGC_9680 = 849
  integer, parameter :: nGC_14309 = 850
  integer, parameter :: nGC_14062 = 851
  integer, parameter :: nGC_14063 = 852
  integer, parameter :: nGC_14019 = 853
  integer, parameter :: nGC_16299 = 854
  integer, parameter :: nGC_14542 = 855
  integer, parameter :: nGC_18823 = 856
  integer, parameter :: nGC_14011 = 857
  integer, parameter :: nGC_17837 = 858
  integer, parameter :: nGC_14013 = 859
  integer, parameter :: nGC_14012 = 860
  integer, parameter :: nGC_9513 = 861
  integer, parameter :: nGC_9512 = 862
  integer, parameter :: nGC_9458 = 863
  integer, parameter :: nGC_9459 = 864
  integer, parameter :: nGC_9517 = 865
  integer, parameter :: nGC_9516 = 866
  integer, parameter :: nGC_9515 = 867
  integer, parameter :: nGC_9514 = 868
  integer, parameter :: nGC_9452 = 869
  integer, parameter :: nGC_9453 = 870
  integer, parameter :: nGC_9519 = 871
  integer, parameter :: nGC_9451 = 872
  integer, parameter :: nGC_9456 = 873
  integer, parameter :: nGC_9457 = 874
  integer, parameter :: nGC_9454 = 875
  integer, parameter :: nGC_9455 = 876
  integer, parameter :: nGC_14905 = 877
  integer, parameter :: nGC_9340 = 878
  integer, parameter :: nGC_14268 = 879
  integer, parameter :: nGC_15204 = 880
  integer, parameter :: nGC_14266 = 881
  integer, parameter :: nGC_14267 = 882
  integer, parameter :: nGC_9329 = 883
  integer, parameter :: nGC_9373 = 884
  integer, parameter :: nGC_17162 = 885
  integer, parameter :: nGC_9376 = 886
  integer, parameter :: nGC_23299 = 887
  integer, parameter :: nGC_9359 = 888
  integer, parameter :: nGC_9358 = 889
  integer, parameter :: nGC_9429 = 890
  integer, parameter :: nGC_9428 = 891
  integer, parameter :: nGC_9355 = 892
  integer, parameter :: nGC_9354 = 893
  integer, parameter :: nGC_9425 = 894
  integer, parameter :: nGC_9424 = 895
  integer, parameter :: nGC_9423 = 896
  integer, parameter :: nGC_9422 = 897
  integer, parameter :: nGC_9353 = 898
  integer, parameter :: nGC_9420 = 899
  integer, parameter :: nGC_9589 = 900
  integer, parameter :: nGC_9580 = 901
  integer, parameter :: nGC_9581 = 902
  integer, parameter :: nGC_9582 = 903
  integer, parameter :: nGC_9584 = 904
  integer, parameter :: nGC_15788 = 905
  integer, parameter :: nGC_9586 = 906
  integer, parameter :: nGC_15462 = 907
  integer, parameter :: nGC_14699 = 908
  integer, parameter :: nGC_14698 = 909
  integer, parameter :: nGC_16240 = 910
  integer, parameter :: nGC_15313 = 911
  integer, parameter :: nGC_9633 = 912
  integer, parameter :: nGC_9631 = 913
  integer, parameter :: nGC_9634 = 914
  integer, parameter :: nGC_9635 = 915
  integer, parameter :: nGC_14604 = 916
  integer, parameter :: nGC_9638 = 917
  integer, parameter :: nGC_9639 = 918
  integer, parameter :: nGC_9739 = 919
  integer, parameter :: nGC_9738 = 920
  integer, parameter :: nGC_15266 = 921
  integer, parameter :: nGC_9733 = 922
  integer, parameter :: nGC_9732 = 923
  integer, parameter :: nGC_9731 = 924
  integer, parameter :: nGC_9730 = 925
  integer, parameter :: nGC_9735 = 926
  integer, parameter :: nGC_14026 = 927
  integer, parameter :: nGC_9421 = 928
  integer, parameter :: nGC_14023 = 929
  integer, parameter :: nGC_14180 = 930
  integer, parameter :: nGC_14029 = 931
  integer, parameter :: nGC_18820 = 932
  integer, parameter :: nGC_2266 = 933
  integer, parameter :: nGC_14014 = 934
  integer, parameter :: nGC_18824 = 935
  integer, parameter :: nGC_9647 = 936
  integer, parameter :: nGC_15171 = 937
  integer, parameter :: nGC_9644 = 938
  integer, parameter :: nGC_9643 = 939
  integer, parameter :: nGC_9435 = 940
  integer, parameter :: nGC_14119 = 941
  integer, parameter :: nGC_9649 = 942
  integer, parameter :: nGC_15172 = 943
  integer, parameter :: nGC_14237 = 944
  integer, parameter :: nGC_14238 = 945
  integer, parameter :: nGC_14333 = 946
  integer, parameter :: nGC_14334 = 947
  integer, parameter :: nGC_9347 = 948
  integer, parameter :: nGC_9344 = 949
  integer, parameter :: nGC_9345 = 950
  integer, parameter :: nGC_16783 = 951
  integer, parameter :: nGC_16782 = 952
  integer, parameter :: nGC_16029 = 953
  integer, parameter :: nGC_16787 = 954
  integer, parameter :: nGC_16786 = 955
  integer, parameter :: nGC_14433 = 956
  integer, parameter :: nGC_16015 = 957
  integer, parameter :: nGC_9463 = 958
  integer, parameter :: nGC_9462 = 959
  integer, parameter :: nGC_9461 = 960
  integer, parameter :: nGC_9460 = 961
  integer, parameter :: nGC_9467 = 962
  integer, parameter :: nGC_9466 = 963
  integer, parameter :: nGC_9464 = 964
  integer, parameter :: nGC_9469 = 965
  integer, parameter :: nGC_9468 = 966
  integer, parameter :: nGC_9548 = 967
  integer, parameter :: nGC_9544 = 968
  integer, parameter :: nGC_9545 = 969
  integer, parameter :: nGC_9547 = 970
  integer, parameter :: nGC_9540 = 971
  integer, parameter :: nGC_9511 = 972
  integer, parameter :: nGC_9542 = 973
  integer, parameter :: nGC_9510 = 974
  integer, parameter :: nGC_22076 = 975
  integer, parameter :: nGC_15312 = 976
  integer, parameter :: nGC_9450 = 977
  integer, parameter :: nGC_9518 = 978
  integer, parameter :: nGC_15380 = 979
  integer, parameter :: nGC_17524 = 980
  integer, parameter :: nGC_17525 = 981
  integer, parameter :: nGC_14725 = 982
  integer, parameter :: nGC_14723 = 983
  integer, parameter :: nGC_14722 = 984
  integer, parameter :: nGC_17522 = 985
  integer, parameter :: nGC_17523 = 986
  integer, parameter :: nGC_16213 = 987
  integer, parameter :: nGC_16212 = 988
  integer, parameter :: nGC_16215 = 989
  integer, parameter :: nGC_16214 = 990
  integer, parameter :: nGC_9611 = 991
  integer, parameter :: nGC_14095 = 992
  integer, parameter :: nGC_14156 = 993
  integer, parameter :: nGC_13973 = 994
  integer, parameter :: nGC_14652 = 995
  integer, parameter :: nGC_14798 = 996
  integer, parameter :: nGC_9608 = 997
  integer, parameter :: nGC_13975 = 998
  integer, parameter :: nGC_13974 = 999
  integer, parameter :: nGC_14792 = 1000
  integer, parameter :: nGC_14793 = 1001
  integer, parameter :: nGC_9601 = 1002
  integer, parameter :: nGC_14791 = 1003
  integer, parameter :: nGC_9607 = 1004
  integer, parameter :: nGC_9606 = 1005
  integer, parameter :: nGC_14794 = 1006
  integer, parameter :: nGC_9604 = 1007
  integer, parameter :: nGC_14374 = 1008
  integer, parameter :: nGC_14375 = 1009
  integer, parameter :: nGC_16851 = 1010
  integer, parameter :: nGC_16854 = 1011
  integer, parameter :: nGC_14072 = 1012
  integer, parameter :: nGC_9577 = 1013
  integer, parameter :: nGC_14982 = 1014
  integer, parameter :: nGC_19749 = 1015
  integer, parameter :: nGC_14987 = 1016
  integer, parameter :: nGC_14986 = 1017
  integer, parameter :: nGC_9523 = 1018
  integer, parameter :: nGC_14989 = 1019
  integer, parameter :: nGC_14988 = 1020
  integer, parameter :: nGC_14107 = 1021
  integer, parameter :: nGC_18546 = 1022
  integer, parameter :: nGC_14381 = 1023
  integer, parameter :: nGC_14382 = 1024
  integer, parameter :: nGC_14269 = 1025
  integer, parameter :: nGC_14543 = 1026
  integer, parameter :: nGC_9500 = 1027
  integer, parameter :: nGC_9501 = 1028
  integer, parameter :: nGC_9502 = 1029
  integer, parameter :: nGC_9503 = 1030
  integer, parameter :: nGC_9504 = 1031
  integer, parameter :: nGC_9505 = 1032
  integer, parameter :: nGC_9506 = 1033
  integer, parameter :: nGC_9507 = 1034
  integer, parameter :: nGC_9508 = 1035
  integer, parameter :: nGC_9509 = 1036
  integer, parameter :: nGC_15004 = 1037
  integer, parameter :: nGC_14015 = 1038
  integer, parameter :: nGC_15003 = 1039
  integer, parameter :: nGC_9614 = 1040
  integer, parameter :: nGC_14780 = 1041
  integer, parameter :: nGC_9476 = 1042
  integer, parameter :: nGC_14277 = 1043
  integer, parameter :: nGC_14276 = 1044
  integer, parameter :: nGC_16853 = 1045
  integer, parameter :: nGC_14858 = 1046
  integer, parameter :: nGC_9598 = 1047
  integer, parameter :: nGC_14855 = 1048
  integer, parameter :: nGC_1206 = 1049
  integer, parameter :: nGC_9348 = 1050
  integer, parameter :: nGC_9349 = 1051
  integer, parameter :: nGC_9438 = 1052
  integer, parameter :: nGC_9342 = 1053
  integer, parameter :: nGC_9343 = 1054
  integer, parameter :: nGC_9436 = 1055
  integer, parameter :: nGC_9437 = 1056
  integer, parameter :: nGC_9346 = 1057
  integer, parameter :: nGC_9431 = 1058
  integer, parameter :: nGC_9432 = 1059
  integer, parameter :: nGC_9433 = 1060
  integer, parameter :: nGC_15071 = 1061
  integer, parameter :: nGC_14359 = 1062
  integer, parameter :: nGC_15074 = 1063
  integer, parameter :: nGC_15075 = 1064
  integer, parameter :: nGC_15076 = 1065
  integer, parameter :: nGC_9489 = 1066
  integer, parameter :: nGC_14369 = 1067
  integer, parameter :: nGC_9488 = 1068
  integer, parameter :: nGC_14581 = 1069
  integer, parameter :: nGC_14580 = 1070
  integer, parameter :: nGC_14809 = 1071
  integer, parameter :: nGC_14614 = 1072
  integer, parameter :: nGC_9481 = 1073
  integer, parameter :: nGC_9482 = 1074
  integer, parameter :: nGC_9485 = 1075
  integer, parameter :: nGC_9487 = 1076
  integer, parameter :: nGC_9486 = 1077
  integer, parameter :: nGC_9720 = 1078
  integer, parameter :: nGC_9721 = 1079
  integer, parameter :: nGC_9722 = 1080
  integer, parameter :: nGC_9723 = 1081
  integer, parameter :: nGC_9724 = 1082
  integer, parameter :: nGC_9725 = 1083
  integer, parameter :: nGC_9726 = 1084
  integer, parameter :: nGC_9727 = 1085
  integer, parameter :: nGC_14037 = 1086
  integer, parameter :: nGC_14036 = 1087
  integer, parameter :: nGC_9397 = 1088
  integer, parameter :: nGC_9390 = 1089
  integer, parameter :: nGC_9399 = 1090
  integer, parameter :: nGC_9398 = 1091
  integer, parameter :: nGC_9410 = 1092
  integer, parameter :: nGC_15810 = 1093
  integer, parameter :: nGC_15999 = 1094
  integer, parameter :: nGC_14743 = 1095
  integer, parameter :: nGC_9553 = 1096
  integer, parameter :: nGC_9552 = 1097
  integer, parameter :: nGC_9551 = 1098
  integer, parameter :: nGC_9550 = 1099
  integer, parameter :: nGC_15073 = 1100
  integer, parameter :: nGC_9498 = 1101
  integer, parameter :: nGC_9499 = 1102
  integer, parameter :: nGC_9496 = 1103
  integer, parameter :: nGC_13981 = 1104
  integer, parameter :: nGC_13986 = 1105
  integer, parameter :: nGC_13987 = 1106
  integer, parameter :: nGC_15059 = 1107
  integer, parameter :: nGC_9380 = 1108
  integer, parameter :: nGC_15809 = 1109
  integer, parameter :: nGC_13977 = 1110
  integer, parameter :: nGC_9391 = 1111
  integer, parameter :: nGC_14972 = 1112
  integer, parameter :: nGC_14634 = 1113
  integer, parameter :: nGC_14636 = 1114
  integer, parameter :: nGC_14639 = 1115
  integer, parameter :: nGC_22440 = 1116
  integer, parameter :: nGC_15449 = 1117
  integer, parameter :: nGC_13997 = 1118
  integer, parameter :: nGC_14405 = 1119
  integer, parameter :: nGC_13993 = 1120
  integer, parameter :: nGC_14318 = 1121
  integer, parameter :: nGC_15423 = 1122
  integer, parameter :: nGC_14675 = 1123
  integer, parameter :: nGC_14313 = 1124
  integer, parameter :: nGC_14310 = 1125
  integer, parameter :: nGC_15424 = 1126
  integer, parameter :: nGC_17036 = 1127
  integer, parameter :: nGC_14810 = 1128
  integer, parameter :: nGC_17035 = 1129
  integer, parameter :: nGC_9479 = 1130
  integer, parameter :: nGC_9579 = 1131
  integer, parameter :: nGC_9578 = 1132
  integer, parameter :: nGC_9573 = 1133
  integer, parameter :: nGC_9572 = 1134
  integer, parameter :: nGC_9574 = 1135
  integer, parameter :: nGC_9576 = 1136
  integer, parameter :: nGC_16822 = 1137
  integer, parameter :: nGC_16823 = 1138
  integer, parameter :: nGC_16821 = 1139
  integer, parameter :: nGC_15607 = 1140
  integer, parameter :: nGC_17368 = 1141
  integer, parameter :: nGC_9567 = 1142
  integer, parameter :: nGC_9564 = 1143
  integer, parameter :: nGC_9449 = 1144
  integer, parameter :: nGC_9563 = 1145
  integer, parameter :: nGC_9561 = 1146
  integer, parameter :: nGC_14701 = 1147
  integer, parameter :: nGC_9568 = 1148
  integer, parameter :: nGC_9442 = 1149
  integer, parameter :: nGC_9379 = 1150
  integer, parameter :: nGC_14394 = 1151
  integer, parameter :: nGC_14395 = 1152
  integer, parameter :: nGC_9562 = 1153
  integer, parameter :: nGC_13976 = 1154
  integer, parameter :: nGC_23301 = 1155
  integer, parameter :: nGC_9603 = 1156
  integer, parameter :: nGC_15318 = 1157
  integer, parameter :: nGC_16051 = 1158
  integer, parameter :: nGC_9600 = 1159
  integer, parameter :: nGC_9448 = 1160
  integer, parameter :: nGC_15407 = 1161
  integer, parameter :: nGC_15998 = 1162
  integer, parameter :: nGC_14906 = 1163
  integer, parameter :: nGC_17218 = 1164
  integer, parameter :: nGC_17219 = 1165
  integer, parameter :: nGC_15791 = 1166
  integer, parameter :: nGC_14700 = 1167
  integer, parameter :: nGC_14703 = 1168
  integer, parameter :: nGC_14702 = 1169
  integer, parameter :: nGC_14147 = 1170
  integer, parameter :: nGC_14146 = 1171
  integer, parameter :: nGC_14907 = 1172
  integer, parameter :: nGC_17217 = 1173
  integer, parameter :: nGC_9599 = 1174
  integer, parameter :: nGC_9612 = 1175
  integer, parameter :: nGC_9613 = 1176
  integer, parameter :: nGC_14781 = 1177
  integer, parameter :: nGC_15369 = 1178
  integer, parameter :: nGC_9595 = 1179
  integer, parameter :: nGC_9594 = 1180
  integer, parameter :: nGC_14682 = 1181
  integer, parameter :: nGC_15473 = 1182
  integer, parameter :: nGC_14047 = 1183
  integer, parameter :: nGC_17165 = 1184
  integer, parameter :: nGC_9495 = 1185
  integer, parameter :: nGC_21499 = 1186
  integer, parameter :: nGC_9597 = 1187
  integer, parameter :: nGC_9351 = 1188
  integer, parameter :: nGC_9350 = 1189
  integer, parameter :: nGC_13957 = 1190
  integer, parameter :: nGC_9596 = 1191
  integer, parameter :: nGC_14561 = 1192
  integer, parameter :: nGC_14560 = 1193
  integer, parameter :: nGC_14563 = 1194
  integer, parameter :: nGC_14562 = 1195
  integer, parameter :: nGC_14279 = 1196
  integer, parameter :: nGC_14278 = 1197
  integer, parameter :: nGC_14567 = 1198
  integer, parameter :: nGC_17369 = 1199
  integer, parameter :: nGC_17367 = 1200
  integer, parameter :: nGC_9583 = 1201
  integer, parameter :: nGC_9585 = 1202
  integer, parameter :: nGC_21425 = 1203
  integer, parameter :: nGC_15464 = 1204
  integer, parameter :: nGC_15463 = 1205
  integer, parameter :: nGC_14054 = 1206
  integer, parameter :: nGC_14211 = 1207
  integer, parameter :: nGC_21788 = 1208
  integer, parameter :: nGC_14859 = 1209
  integer, parameter :: nGC_14594 = 1210
  integer, parameter :: nGC_9535 = 1211
  integer, parameter :: nGC_14590 = 1212
  integer, parameter :: nGC_9530 = 1213
  integer, parameter :: nGC_9533 = 1214
  integer, parameter :: nGC_9532 = 1215
  integer, parameter :: nGC_16475 = 1216
  integer, parameter :: nGC_18828 = 1217
  integer, parameter :: nGC_9434 = 1218
  integer, parameter :: nGC_15173 = 1219
  integer, parameter :: nGC_9341 = 1220
  integer, parameter :: nGC_9430 = 1221
  integer, parameter :: nGC_16760 = 1222
  integer, parameter :: nGC_17370 = 1223
  integer, parameter :: nGC_14283 = 1224
  integer, parameter :: nGC_15933 = 1225
  integer, parameter :: nGC_16750 = 1226
  integer, parameter :: nGC_14129 = 1227
  integer, parameter :: nGC_14182 = 1228
  integer, parameter :: nGC_14181 = 1229
  integer, parameter :: nGC_14225 = 1230
  integer, parameter :: nGC_16053 = 1231
  integer, parameter :: nGC_16052 = 1232
  integer, parameter :: nGC_19500 = 1233
  integer, parameter :: nGC_14582 = 1234
  integer, parameter :: nGC_9524 = 1235
  integer, parameter :: nGC_9525 = 1236
  integer, parameter :: nGC_9400 = 1237
  integer, parameter :: nGC_9405 = 1238
  integer, parameter :: nGC_16017 = 1239
  integer, parameter :: nGC_16016 = 1240
  integer, parameter :: nGC_15061 = 1241
  integer, parameter :: nGC_15060 = 1242
  integer, parameter :: nGC_14294 = 1243
  integer, parameter :: nGC_16054 = 1244
  integer, parameter :: nGC_22507 = 1245
  integer, parameter :: nGC_17265 = 1246
  integer, parameter :: nGC_14635 = 1247
  integer, parameter :: nGC_14712 = 1248
  integer, parameter :: nGC_14908 = 1249
  integer, parameter :: nGC_14226 = 1250
  integer, parameter :: nGC_14312 = 1251
  integer, parameter :: nGC_16117 = 1252
  integer, parameter :: nGC_14396 = 1253
  integer, parameter :: nGC_22006 = 1254
  integer, parameter :: nGC_15812 = 1255
  integer, parameter :: nGC_15811 = 1256
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
