!******************************************************************************!
!                                                                              !
!    class_tree.f90                                                            !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_tree.f90                                 |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_tree
  use class_vertices
  use constants_mdl
  use tcVUUa1, only: treeVUUa1
  use tcSS2, only: treeSS2
  use tcFaF0, only: treeFaF0
  use tcSV0, only: treeSV0
  use tcUaVU0, only: treeUaVU0
  use tcFFa1, only: treeFFa1
  use tcVVSS0, only: treeVVSS0
  use tcFaFS0, only: treeFaFS0
  use tcSS1, only: treeSS1
  use tcFVFa0, only: treeFVFa0
  use tcSUUa0, only: treeSUUa0
  use tcVV0, only: treeVV0
  use tcSSV1, only: treeSSV1
  use tcSSVV0, only: treeSSVV0
  use tcSVVS0, only: treeSVVS0
  use tcVVS0, only: treeVVS0
  use tcSFaF2, only: treeSFaF2
  use tcVSVS0, only: treeVSVS0
  use tcSUaSU0, only: treeSUaSU0
  use tcFSFa2, only: treeFSFa2
  use tcVVV0, only: treeVVV0
  use tcVFFa0, only: treeVFFa0
  use tcVUVUa0, only: treeVUVUa0
  use tcFaVF0, only: treeFaVF0
  use tcUVVUa0, only: treeUVVUa0
  use tcFaSF1, only: treeFaSF1
  use tcVSS1, only: treeVSS1
  use tcUaUV0, only: treeUaUV0
  use tcFaSF2, only: treeFaSF2
  use tcSUSUa0, only: treeSUSUa0
  use tcUaVUV0, only: treeUaVUV0
  use tcFaFV1, only: treeFaFV1
  use tcVUaUV0, only: treeVUaUV0
  use tcSFaF1, only: treeSFaF1
  use tcVV1, only: treeVV1
  use tcUaSSU0, only: treeUaSSU0
  use tcFSFa1, only: treeFSFa1
  use tcFaF2, only: treeFaF2
  use tcVVV1, only: treeVVV1
  use tcSSUaU0, only: treeSSUaU0
  use tcUaUVV0, only: treeUaUVV0
  use tcSUaU0, only: treeSUaU0
  use tcSSV0, only: treeSSV0
  use tcVSSV0, only: treeVSSV0
  use tcSS0, only: treeSS0
  use tcVVVV0, only: treeVVVV0
  use tcVV3, only: treeVV3
  use tcSFaF0, only: treeSFaF0
  use tcSUUaS0, only: treeSUUaS0
  use tcSSUUa0, only: treeSSUUa0
  use tcVUUaV0, only: treeVUUaV0
  use tcFSFa0, only: treeFSFa0
  use tcFFaS0, only: treeFFaS0
  use tcFFa2, only: treeFFa2
  use tcUSSUa0, only: treeUSSUa0
  use tcVSS0, only: treeVSS0
  use tcSUaUS0, only: treeSUaUS0
  use tcFaFV0, only: treeFaFV0
  use tcUaSU0, only: treeUaSU0
  use tcUUaSS0, only: treeUUaSS0
  use tcSVSV0, only: treeSVSV0
  use tcSFFa0, only: treeSFFa0
  use tcVFaF0, only: treeVFaF0
  use tcUVUa0, only: treeUVUa0
  use tcUUaV1, only: treeUUaV1
  use tcVSV0, only: treeVSV0
  use tcSVV0, only: treeSVV0
  use tcVUaU0, only: treeVUaU0
  use tcUUaVV0, only: treeUUaVV0
  use tcSSS0, only: treeSSS0
  use tcSSSS0, only: treeSSSS0
  use tcUaSUS0, only: treeUaSUS0
  use tcFaF1, only: treeFaF1
  use tcUSUaS0, only: treeUSUaS0
  use tcUVUaV0, only: treeUVUaV0
  use tcVFaF1, only: treeVFaF1
  use tcFaFS2, only: treeFaFS2
  use tcVS0, only: treeVS0
  use tcVV2, only: treeVV2
  use tcUaUS0, only: treeUaUS0
  use tcUaUSS0, only: treeUaUSS0
  use tcFVFa1, only: treeFVFa1
  use tcFFaS1, only: treeFFaS1
  use tcSVS0, only: treeSVS0
  use tcVUaU1, only: treeVUaU1
  use tcFFaS2, only: treeFFaS2
  use tcFFaV0, only: treeFFaV0
  use tcFFa0, only: treeFFa0
  use tcUSUa0, only: treeUSUa0
  use tcVUUa0, only: treeVUUa0
  use tcVVVV1, only: treeVVVV1
  use tcSFFa1, only: treeSFFa1
  use tcSFFa2, only: treeSFFa2
  use tcUUaV0, only: treeUUaV0
  use tcFaFS1, only: treeFaFS1
  use tcVFFa1, only: treeVFFa1
  use tcFaVF1, only: treeFaVF1
  use tcVVUaU0, only: treeVVUaU0
  use tcFaSF0, only: treeFaSF0
  use tcUUaS0, only: treeUUaS0
  use tcUaUV1, only: treeUaUV1
  use tcVVUUa0, only: treeVVUUa0
  use tcUaVVU0, only: treeUaVVU0
  use tcVUaVU0, only: treeVUaVU0
  use tcFFaV1, only: treeFFaV1
  implicit none

  interface compute_tree_mdl
    module procedure computeTree2, computeTree3, computeTree4, computeTree5,   &
    computeTree6, computeTree7, computeTree8
  end interface 

  contains

  subroutine computeTree2(ty, co, w1, P1, PL1, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case(SS2)
      call treeSS2(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FaF0)
      call treeFaF0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(SV0)
      call treeSV0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FFa1)
      call treeFFa1(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(SS1)
      call treeSS1(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(VV0)
      call treeVV0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(VV1)
      call treeVV1(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FaF2)
      call treeFaF2(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(SS0)
      call treeSS0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(VV3)
      call treeVV3(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FFa2)
      call treeFFa2(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FaF1)
      call treeFaF1(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(VS0)
      call treeVS0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(VV2)
      call treeVV2(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case(FFa0)
      call treeFFa0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree2

  subroutine computeTree3(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case(VUUa1)
      call treeVUUa1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UaVU0)
      call treeUaVU0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaFS0)
      call treeFaFS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FVFa0)
      call treeFVFa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SUUa0)
      call treeSUUa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SSV1)
      call treeSSV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(VVS0)
      call treeVVS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(SFaF2)
      call treeSFaF2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FSFa2)
      call treeFSFa2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VVV0)
      call treeVVV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(VFFa0)
      call treeVFFa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaVF0)
      call treeFaVF0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaSF1)
      call treeFaSF1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VSS1)
      call treeVSS1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(UaUV0)
      call treeUaUV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaSF2)
      call treeFaSF2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaFV1)
      call treeFaFV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SFaF1)
      call treeSFaF1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FSFa1)
      call treeFSFa1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VVV1)
      call treeVVV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(SUaU0)
      call treeSUaU0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SSV0)
      call treeSSV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(SFaF0)
      call treeSFaF0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FSFa0)
      call treeFSFa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FFaS0)
      call treeFFaS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VSS0)
      call treeVSS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(FaFV0)
      call treeFaFV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UaSU0)
      call treeUaSU0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SFFa0)
      call treeSFFa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VFaF0)
      call treeVFaF0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UVUa0)
      call treeUVUa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UUaV1)
      call treeUUaV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VSV0)
      call treeVSV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(SVV0)
      call treeSVV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(VUaU0)
      call treeVUaU0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SSS0)
      call treeSSS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(VFaF1)
      call treeVFaF1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaFS2)
      call treeFaFS2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UaUS0)
      call treeUaUS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FVFa1)
      call treeFVFa1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FFaS1)
      call treeFFaS1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SVS0)
      call treeSVS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,      &
      VB_last)
    case(VUaU1)
      call treeVUaU1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FFaS2)
      call treeFFaS2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FFaV0)
      call treeFFaV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(USUa0)
      call treeUSUa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VUUa0)
      call treeVUUa0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SFFa1)
      call treeSFFa1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(SFFa2)
      call treeSFFa2(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UUaV0)
      call treeUUaV0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaFS1)
      call treeFaFS1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(VFFa1)
      call treeVFFa1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaVF1)
      call treeFaVF1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FaSF0)
      call treeFaSF0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UUaS0)
      call treeUUaS0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(UaUV1)
      call treeUaUV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case(FFaV1)
      call treeFFaV1(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,     &
      VB_last)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree3

  subroutine computeTree4(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m&
  , wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
    complex(kind=dp), intent(in), dimension(0:3) :: w3
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case(VVSS0)
      call treeVVSS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(SSVV0)
      call treeSSVV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(SVVS0)
      call treeSVVS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(VSVS0)
      call treeVSVS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(SUaSU0)
      call treeSUaSU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VUVUa0)
      call treeVUVUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UVVUa0)
      call treeUVVUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SUSUa0)
      call treeSUSUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UaVUV0)
      call treeUaVUV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VUaUV0)
      call treeVUaUV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UaSSU0)
      call treeUaSSU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SSUaU0)
      call treeSSUaU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UaUVV0)
      call treeUaUVV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VSSV0)
      call treeVSSV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(VVVV0)
      call treeVVVV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(SUUaS0)
      call treeSUUaS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SSUUa0)
      call treeSSUUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VUUaV0)
      call treeVUUaV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(USSUa0)
      call treeUSSUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SUaUS0)
      call treeSUaUS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UUaSS0)
      call treeUUaSS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SVSV0)
      call treeSVSV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(UUaVV0)
      call treeUUaVV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(SSSS0)
      call treeSSSS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(UaSUS0)
      call treeUaSUS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(USUaS0)
      call treeUSUaS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UVUaV0)
      call treeUVUaV0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UaUSS0)
      call treeUaUSS0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VVVV1)
      call treeVVVV1(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,    &
      wout, last, VB_last)
    case(VVUaU0)
      call treeVVUaU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VVUUa0)
      call treeVVUUa0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(UaVVU0)
      call treeUaVVU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case(VUaVU0)
      call treeVUaVU0(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m,   &
      wout, last, VB_last)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree4

  subroutine computeTree5(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
    complex(kind=dp), intent(in), dimension(0:3) :: w3
    complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
    complex(kind=dp), intent(in), dimension(0:3) :: w4
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree5

  subroutine computeTree6(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
    complex(kind=dp), intent(in), dimension(0:3) :: w3
    complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
    complex(kind=dp), intent(in), dimension(0:3) :: w4
    complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
    complex(kind=dp), intent(in), dimension(0:3) :: w5
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree6

  subroutine computeTree7(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, w6, P6, PL6, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
    complex(kind=dp), intent(in), dimension(0:3) :: w3
    complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
    complex(kind=dp), intent(in), dimension(0:3) :: w4
    complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
    complex(kind=dp), intent(in), dimension(0:3) :: w5
    complex(kind=dp), intent(in), dimension(0:3) :: P6, PL6
    complex(kind=dp), intent(in), dimension(0:3) :: w6
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree7

  subroutine computeTree8(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
  , PL4, w5, P5, PL5, w6, P6, PL6, w7, P7, PL7, den, m, wout, last)
    integer, intent(in) :: ty
    logical :: VB_last
    logical, intent(in) :: last
    complex(kind=dp), dimension(0:), intent(in) :: co
    complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
    complex(kind=dp), intent(in), dimension(0:3) :: w1
    complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
    complex(kind=dp), intent(in), dimension(0:3) :: w2
    complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
    complex(kind=dp), intent(in), dimension(0:3) :: w3
    complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
    complex(kind=dp), intent(in), dimension(0:3) :: w4
    complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
    complex(kind=dp), intent(in), dimension(0:3) :: w5
    complex(kind=dp), intent(in), dimension(0:3) :: P6, PL6
    complex(kind=dp), intent(in), dimension(0:3) :: w6
    complex(kind=dp), intent(in), dimension(0:3) :: P7, PL7
    complex(kind=dp), intent(in), dimension(0:3) :: w7
    complex(kind=dp), intent(in) :: m
    complex(kind=dp), intent(in) :: den
    complex(kind=dp), dimension(0:3), intent(out) :: wout
    character(len=3) :: ty_str
    complex(kind=dp), dimension(0:3) :: pl, p

    wout(:) = 0.0d0
    VB_last = .false.

    select case(ty)
    case default
      write(ty_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // ty_str, where='compute_tree_mdl')
    end select 
    if (last .eqv. .false.) then
      wout(:) = cima * wout(:)/den
    else
      if (VB_last) wout(0) = - wout(0)
    end if 
  end subroutine computeTree8

  subroutine helicity_conservation_mdl(fheT, typeT, fhfilter, j, w, wOut, ml,  &
  last_tl)
    integer, dimension(0:), intent(inout) :: fheT
    logical, dimension(:), intent(inout) :: fhfilter
    integer, intent(in), dimension(:) :: w
    integer, intent(in) :: wOut, typeT, j
    logical, intent(in) :: ml, last_tl
    integer, parameter :: pos_hel = 1
    integer, parameter :: neg_hel = -1
    integer, parameter :: unpol = 0
    integer, parameter :: zero_current = 3
    integer, parameter :: not_set = 111

    select case(typeT)
    case(FFaS0)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FFaS1)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FFaS2)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(VFaF0)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(VFaF1)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaF0)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FaF1)
      fheT(wOut) = unpol
    case(FaF2)
      fheT(wOut) = unpol
    case(FFaV0)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FFaV1)
      if (fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FSFa0)
      if (ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FSFa1)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FSFa2)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaVF0)
      if (ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaVF1)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FVFa0)
      if (ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FVFa1)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaFS0)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FaFS1)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FaFS2)
      if (fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FFa0)
      fheT(wOut) = unpol
    case(FFa1)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FFa2)
      fheT(wOut) = unpol
    case(FaFV0)
      if (fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(FaFV1)
      if (fheT(w(1)) .eq. unpol .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. pos_hel .and. fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(fheT(w(1)) .eq. neg_hel .and. fheT(w(2)) .eq. unpol) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(SFFa0)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(SFFa1)
      if (fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(SFFa2)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(SFaF0)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(SFaF1)
      if (fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(SFaF2)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(2)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaSF0)
      if (ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaSF1)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(1)) .eq. neg_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(FaSF2)
      if (ml .and. fheT(w(1)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(1)) .eq. pos_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(fheT(w(1)) .eq. neg_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else
        fheT(wOut) = unpol
      end if 
    case(VFFa0)
      if (fheT(w(2)) .eq. pos_hel) then
        fhfilter(j) = .false.
        if (fheT(wOut) .eq. not_set) fheT(wOut) = zero_current
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. unpol) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case(VFFa1)
      if (ml .and. fheT(w(2)) .eq. pos_hel) then
        fheT(wOut) = pos_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else if(ml .and. fheT(w(2)) .eq. neg_hel) then
        fheT(wOut) = neg_hel
        if (last_tl) then
          fheT(wOut) = - fheT(wOut)
        end if 
      else
        fheT(wOut) = unpol
      end if 
    case default
      fheT(wOut) = unpol
    end select 
  end subroutine helicity_conservation_mdl
end module class_tree
