!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_couplings_mdl1()
      coupl(nGC_9261) = -cima*ee**2d0*vev/cw
      coupl(nGC_9263) = -cima*ee**2d0/(2d0*cw)
      coupl(nGC_9262) = cima*ee**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_9153) = cima*ee**2d0/sw**3d0
      coupl(nGC_9155) = -cima*ee**2d0*vev/sw
      coupl(nGC_9154) = cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_131) = -sqrt(2d0)*ydo/2d0
      coupl(nGC_68) = -ee**2d0/(2d0*sw)
      coupl(nGC_9121) = -cima*ee**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_69) = -cima*ee**2d0/(2d0*sw)
      coupl(nGC_206) = cima/(2d0*cMW)
      coupl(nGC_9285) = -cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**  &
                        2d0)/(cw**3d0*sw**2d0)
      coupl(nGC_9101) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**3d0*sw**2d0)
      coupl(nGC_MZ_GF) = cMZ
      coupl(nGC_28) = -cima*ee**2d0/(2d0*sw**2d0) - cima*lam/2d0
      coupl(nGC_22) = -cima*lam/2d0
      coupl(nGC_23) = -cima*lam
      coupl(nGC_20) = -cima*gs**2d0
      coupl(nGC_21) = cima*gs**2d0
      coupl(nGC_26) = cima*ee**2d0/(4d0*sw**2d0) - cima*lam/2d0
      coupl(nGC_27) = cima*ee**2d0/(4d0*sw**2d0) - cima*lam/2d0 + cima*ee**2d0 &
                      /(4d0*cw**2d0)
      coupl(nGC_24) = -3d0*cima*lam/2d0
      coupl(nGC_25) = -cima*ee**2d0/(4d0*sw**2d0) - cima*lam - cima*ee**2d0/(  &
                      4d0*cw**2d0)
      coupl(nGC_9279) = -cima*ee
      coupl(nGC_93) = -cima*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0 - cima&
                      *ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_9276) = ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
      coupl(nGC_9277) = -ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
      coupl(nGC_9274) = cima*ee/3d0
      coupl(nGC_9109) = -cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw**2d0)
      coupl(nGC_9228) = 2d0*cima*cw*ee**2d0/sw
      coupl(nGC_91) = -cima*cw**2d0*ee**2d0/(4d0*sw**2d0) - cima*ee**2d0/2d0 - &
                      cima*ee**2d0*sw**2d0/(4d0*cw**2d0)
      coupl(nGC_9074) = 2d0*cima*ee**2d0*(cw - sw)*(cw + sw)/(cw*sw)
      coupl(nGC_9076) = cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw**2d0*sw)
      coupl(nGC_9077) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9070) = cima*ee/sw
      coupl(nGC_9071) = -2d0*cima*ee**2d0*(cw - sw)*(cw + sw)/(cw*sw)
      coupl(nGC_9072) = cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw*sw**2d0)
      coupl(nGC_9294) = -2d0*cima*ee
      coupl(nGC_9295) = 2d0*cima*ee
      coupl(nGC_9296) = -2d0*cima*ee**2d0
      coupl(nGC_9297) = -cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw*sw)
      coupl(nGC_9290) = -cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**  &
                        2d0)/(cw**2d0*sw**3d0)
      coupl(nGC_9291) = cima*ee**2d0*vev*(cw**2d0 + sw**2d0)**2d0/(cw**2d0*sw**&
                        2d0)
      coupl(nGC_9293) = cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(2d0*cw**2d0*sw**&
                        2d0)
      coupl(nGC_9298) = cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw*sw**2d0)
      coupl(nGC_9299) = -cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw**2d0*sw)
      coupl(nGC_118) = cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/(  &
                       4d0*cw)
      coupl(nGC_9199) = -2d0*cima*ee**2d0/sw**3d0
      coupl(nGC_9196) = -ee/(2d0*sw**2d0)
      coupl(nGC_126) = -sqrt(2d0)*cima*yb/2d0
      coupl(nGC_122) = -cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) - cima*ee**2d0* &
                       vev - cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_123) = cima*cw**2d0*ee**2d0*vev/(2d0*sw**2d0) + cima*ee**2d0*  &
                       vev + cima*ee**2d0*sw**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_120) = cima*cw*ee**2d0*vev/(2d0*sw**2d0) - cima*ee**2d0*vev/(  &
                       2d0*cw)
      coupl(nGC_121) = -cima*cw**2d0*ee**2d0*vev/(4d0*sw**2d0) - cima*ee**2d0* &
                       vev/2d0 - cima*ee**2d0*sw**2d0*vev/(4d0*cw**2d0)
      coupl(nGC_9207) = ee**2d0/(2d0*sw**2d0)
      coupl(nGC_1584) = -coupl(nGC_20) + coupl(nGC_21)
      coupl(nGC_9204) = sqrt(2d0)/2d0
      coupl(nGC_128) = -sqrt(2d0)*cima*yc/2d0
      coupl(nGC_129) = sqrt(2d0)*yc/2d0
      coupl(nGC_100) = cima*ee**2d0*vev/(2d0*cw)
      coupl(nGC_MMW_GF) = -cMW*cima
      coupl(nGC_1566) = -coupl(nGC_20) - coupl(nGC_21)
      coupl(nGC_1564) = coupl(nGC_20) + coupl(nGC_21)
      coupl(nGC_1562) = coupl(nGC_20) - coupl(nGC_21)
      coupl(nGC_77) = 2d0*cima*cw*ee**2d0/sw
      coupl(nGC_9100) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**2d0*sw**3d0)
      coupl(nGC_9108) = cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw)
      coupl(nGC_97) = -ee**2d0*vev/(4d0*cw**2d0)
      coupl(nGC_141) = -sqrt(2d0)*cima*ys/2d0
      coupl(nGC_I) = cima
      coupl(nGC_109) = ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_MW_GF) = cMW*cima
      coupl(nGC_3) = -cima*ee
      coupl(nGC_2) = -2d0*cima*ee/3d0
      coupl(nGC_1) = cima*ee/3d0
      coupl(nGC_7) = -cima*ee**2d0
      coupl(nGC_6) = 2d0*cima*ee
      coupl(nGC_5) = -2d0*cima*ee
      coupl(nGC_4) = cima*ee
      coupl(nGC_9) = -2d0*cima*ee**2d0
      coupl(nGC_8) = cima*ee**2d0
      coupl(nGC_48) = -cima*ee**2d0/sw**2d0
      coupl(nGC_49) = cima*ee**2d0/sw**2d0
      coupl(nGC_MI) = -cima
      coupl(nGC_53) = ee**2d0/(2d0*sw**2d0)
      coupl(nGC_52) = ee**2d0/(4d0*sw**2d0)
      coupl(nGC_51) = 2d0*cima*ee**2d0/sw**2d0
      coupl(nGC_50) = -2d0*cima*ee**2d0/sw**2d0
      coupl(nGC_57) = 2d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_56) = -2d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_55) = cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_54) = -cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_59) = -cima*ee/(2d0*sw)
      coupl(nGC_58) = -ee/(2d0*sw)
      coupl(nGC_46) = -cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_2546) = -2d0*coupl(nGC_8)
      coupl(nGC_9241) = -2d0*cima*cw**2d0*ee**2d0/sw**3d0
      coupl(nGC_9247) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**2d0*sw**3d0)
      coupl(nGC_9081) = -cima*ee*(cw - sw)*(cw + sw)/(2d0*cw*sw)
      coupl(nGC_9082) = cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw**2d0)
      coupl(nGC_9250) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**2d0*sw**3d0)
      coupl(nGC_9190) = -cima*ee/(2d0*sw**2d0)
      coupl(nGC_107) = cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_9195) = ee/(2d0*sw)
      coupl(nGC_108) = ee**2d0*vev/(4d0*sw**2d0)
      coupl(nGC_9253) = -2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_19) = cima*gs
      coupl(nGC_9220) = -sqrt(2d0)*cima/2d0
      coupl(nGC_654) = -coupl(nGC_77)
      coupl(nGC_18) = -gs
      coupl(nGC_1570) = -coupl(nGC_21)
      coupl(nGC_9142) = -cima*ee**2d0*vev/sw**2d0
      coupl(nGC_127) = cima*yc
      coupl(nGC_9159) = cima*ee**2d0*vev/sw
      coupl(nGC_9318) = -gs
      coupl(nGC_95) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0 + cima*&
                      ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_MT) = -cMT*cima
      coupl(nGC_9158) = -cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_506) = -coupl(nGC_129)
      coupl(nGC_9099) = -cima*ee**2d0*(cw - sw)**2d0*(cw + sw)**2d0/(cw**2d0*sw&
                        **2d0)
      coupl(nGC_9314) = -cima*ee**2d0/(2d0*cw**2d0)
      coupl(nGC_MZ) = cMZ**2d0*cima
      coupl(nGC_17) = -2d0*gs
      coupl(nGC_16) = ee**2d0/(2d0*cw)
      coupl(nGC_15) = cima*ee**2d0/(2d0*cw)
      coupl(nGC_14) = -cima*ee**2d0/(2d0*cw)
      coupl(nGC_13) = -ee**2d0/(2d0*cw)
      coupl(nGC_12) = ee**2d0/(4d0*cw**2d0)
      coupl(nGC_11) = -ee**2d0/(4d0*cw**2d0)
      coupl(nGC_10) = 2d0*cima*ee**2d0
      coupl(nGC_96) = cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 + cima*&
                      ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_9184) = cima*ee/(2d0*sw**2d0)
      coupl(nGC_9180) = 4d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_135) = -sqrt(2d0)*cima*ye/2d0
      coupl(nGC_134) = -sqrt(2d0)*ye/2d0
      coupl(nGC_137) = -sqrt(2d0)*ym/2d0
      coupl(nGC_136) = -cima*ym
      coupl(nGC_480) = 2d0*coupl(nGC_21)
      coupl(nGC_9214) = ee**2d0/sw
      coupl(nGC_9215) = -ee**2d0/(2d0*sw**2d0)
      coupl(nGC_138) = -sqrt(2d0)*cima*ym/2d0
      coupl(nGC_94) = -cima*cw**2d0*ee**2d0/(2d0*sw**2d0) + cima*ee**2d0 - cima&
                      *ee**2d0*sw**2d0/(2d0*cw**2d0)
      coupl(nGC_1514) = -coupl(nGC_4)
      coupl(nGC_1596) = -2d0*coupl(nGC_48)
      coupl(nGC_9157) = -sqrt(2d0)/2d0
      coupl(nGC_92) = -cima*cw**2d0*ee**2d0/(4d0*sw**2d0) + cima*ee**2d0/2d0 - &
                      cima*ee**2d0*sw**2d0/(4d0*cw**2d0)
      coupl(nGC_9156) = -cima*ee**2d0/(2d0*sw)
      coupl(nGC_1572) = -2d0*coupl(nGC_21)
      coupl(nGC_9141) = cima*ee**2d0*vev/sw**3d0
      coupl(nGC_9116) = 2d0*cima*ee/sw
      coupl(nGC_574) = -coupl(nGC_131)
      coupl(nGC_MB) = -cMB*cima
      coupl(nGC_44) = -ee**2d0/(4d0*sw**2d0)
      coupl(nGC_45) = -cima*ee**2d0/(4d0*sw**2d0)
      coupl(nGC_47) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_40) = cw*ee**2d0/(4d0*sw**2d0) + ee**2d0/(4d0*cw)
      coupl(nGC_41) = cw*ee**2d0/(2d0*sw**2d0) - ee**2d0/(2d0*cw)
      coupl(nGC_42) = cw*ee**2d0/(2d0*sw**2d0) + ee**2d0/(2d0*cw)
      coupl(nGC_43) = -ee**2d0/(2d0*sw**2d0)
      coupl(nGC_9252) = 4d0*cima*cw*ee**2d0/sw
      coupl(nGC_9254) = 2d0*cima*ee**2d0/sw
      coupl(nGC_9256) = 4d0*cima*cw**2d0*ee**2d0/sw**3d0
      coupl(nGC_9257) = -4d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_9258) = cima*ee*sw/(3d0*cw)
      coupl(nGC_9259) = cima*ee/(3d0*cw)
      coupl(nGC_9092) = -cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/(&
                        cw**3d0*sw**2d0)
      coupl(nGC_9093) = -cima*ee**2d0*vev/sw**3d0
      coupl(nGC_9090) = -cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(cw**2d0*sw**2d0)
      coupl(nGC_9091) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**2d0*sw**3d0)
      coupl(nGC_9095) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_9311) = -cima*ee**2d0/cw
      coupl(nGC_9310) = -2d0*gs
      coupl(nGC_9313) = cima*ee**2d0/cw
      coupl(nGC_9312) = cima*ee**2d0/(2d0*cw**2d0)
      coupl(nGC_9315) = ee**2d0/cw
      coupl(nGC_174) = cima*gs
      coupl(nGC_9317) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9316) = -ee**2d0/(2d0*cw**2d0)
      coupl(nGC_9183) = -cima*ee/(2d0*sw)
      coupl(nGC_9171) = cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_9170) = -cima*ee**2d0/sw
      coupl(nGC_9173) = 2d0*cima*ee**2d0/sw**3d0
      coupl(nGC_9172) = -2d0*cima*ee**2d0/sw**2d0
      coupl(nGC_9179) = -4d0*cima*cw**2d0*ee**2d0/sw**3d0
      coupl(nGC_9178) = 4d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_130) = -cima*ydo
      coupl(nGC_9243) = -4d0*cima*cw*ee**2d0/sw
      coupl(nGC_133) = -cima*ye
      coupl(nGC_9242) = 2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_132) = -sqrt(2d0)*cima*ydo/2d0
      coupl(nGC_9216) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9246) = cima*ee**2d0*(cw - sw)**2d0*(cw + sw)**2d0/(cw**2d0*sw &
                        **2d0)
      coupl(nGC_9217) = -sqrt(2d0)/2d0
      coupl(nGC_9245) = -2d0*cima*ee**2d0/sw
      coupl(nGC_9210) = cima*ee**2d0/sw
      coupl(nGC_9244) = 2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_29) = -cima*ee**2d0/(2d0*sw**2d0) - cima*lam/2d0 - cima*ee**2d0&
                      /(2d0*cw**2d0)
      coupl(nGC_9189) = cima*ee/(2d0*sw)
      coupl(nGC_9249) = cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(cw**2d0*sw**2d0)
      coupl(nGC_9248) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**3d0*sw**2d0)
      coupl(nGC_9211) = -cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_146) = -sqrt(2d0)*ytau/2d0
      coupl(nGC_9083) = -cima*ee*(cw**2d0 + sw**2d0)/(2d0*cw**2d0*sw)
      coupl(nGC_9143) = -cima*ee**2d0/(2d0*sw**2d0)
      coupl(nGC_9278) = -2d0*cima*ee/3d0
      coupl(nGC_150) = sqrt(2d0)*yup/2d0
      coupl(nGC_140) = -sqrt(2d0)*ys/2d0
      coupl(nGC_9322) = 2d0*cima*gs**2d0
      coupl(nGC_99) = -cima*ee**2d0*vev/(2d0*cw)
      coupl(nGC_98) = ee**2d0*vev/(4d0*cw**2d0)
      coupl(nGC_1160) = -coupl(nGC_18)
      coupl(nGC_746) = -coupl(nGC_3)
      coupl(nGC_75) = cima*cw*ee**2d0/sw
      coupl(nGC_74) = -cima*cw*ee**2d0/sw
      coupl(nGC_76) = -2d0*cima*cw*ee**2d0/sw
      coupl(nGC_71) = -cima*ee**2d0/sw
      coupl(nGC_70) = cima*ee**2d0/(2d0*sw)
      coupl(nGC_73) = ee**2d0/sw
      coupl(nGC_72) = ee**2d0/(2d0*sw)
      coupl(nGC_90) = -cima*cw*ee**2d0/sw + cima*ee**2d0*sw/cw
      coupl(nGC_9212) = -sqrt(2d0)/2d0
      coupl(nGC_9275) = -ee*(cw**2d0 + sw**2d0)/(2d0*cw*sw)
      coupl(nGC_78) = cima*ee*sw/(3d0*cw)
      coupl(nGC_9255) = -4d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_79) = -2d0*cima*ee*sw/(3d0*cw)
      coupl(nGC_117) = -cima*cw*ee**2d0*vev/(4d0*sw**2d0) + cima*ee**2d0*vev/( &
                       4d0*cw)
      coupl(nGC_9229) = -cima*cw*ee**2d0/sw**2d0
      coupl(nGC_101) = -cima*lam*vev/2d0
      coupl(nGC_102) = -3d0*cima*lam*vev/2d0
      coupl(nGC_103) = -ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_104) = -ee**2d0*vev/(4d0*sw**2d0)
      coupl(nGC_105) = -cima*ee**2d0*vev/(4d0*sw**2d0)
      coupl(nGC_106) = -cima*ee**2d0*vev/(2d0*sw**2d0)
      coupl(nGC_9221) = sqrt(2d0)/2d0
      coupl(nGC_9223) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9222) = -sqrt(2d0)/2d0
      coupl(nGC_9227) = sqrt(2d0)/2d0
      coupl(nGC_9152) = -cima*ee**2d0/sw**2d0
      coupl(nGC_652) = -coupl(nGC_77)/2d0
      coupl(nGC_89) = cima*cw*ee**2d0/sw - cima*ee**2d0*sw/cw
      coupl(nGC_9124) = -cima*lam/2d0
      coupl(nGC_9073) = -cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw**2d0*sw)
      coupl(nGC_9122) = cima*ee**2d0/(2d0*cw)
      coupl(nGC_9123) = -cima*vev/2d0
      coupl(nGC_3142) = -coupl(nGC_10)
      coupl(nGC_3140) = coupl(nGC_10)/2d0
      coupl(nGC_9292) = cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0&
                        )/(cw**3d0*sw**2d0)
      coupl(nGC_214) = 1d0/(2d0*cMZ)
      coupl(nGC_210) = -cima/(2d0*cMW)
      coupl(nGC_9213) = -sqrt(2d0)*cima/2d0
      coupl(nGC_149) = -sqrt(2d0)*cima*yup/2d0
      coupl(nGC_922) = -coupl(nGC_137)
      coupl(nGC_148) = cima*yup
      coupl(nGC_9305) = sqrt(2d0)*cima*ee/(2d0*sw)
      coupl(nGC_119) = -cima*cw*ee**2d0*vev/(2d0*sw**2d0) - cima*ee**2d0*vev/( &
                       2d0*cw)
      coupl(nGC_9120) = cima*ee**2d0*vev/cw
      coupl(nGC_9208) = -sqrt(2d0)*cima/2d0
      coupl(nGC_39) = cw*ee**2d0/(4d0*sw**2d0) - ee**2d0/(4d0*cw)
      coupl(nGC_38) = cima*cw*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0/(2d0*cw)
      coupl(nGC_31) = -cw*ee**2d0/(2d0*sw**2d0) - ee**2d0/(2d0*cw)
      coupl(nGC_30) = cima*ee**2d0/(2d0*sw**2d0) - cima*lam + cima*ee**2d0/(2d0&
                      *cw**2d0)
      coupl(nGC_33) = -cw*ee**2d0/(4d0*sw**2d0) - ee**2d0/(4d0*cw)
      coupl(nGC_32) = -cw*ee**2d0/(2d0*sw**2d0) + ee**2d0/(2d0*cw)
      coupl(nGC_35) = -cima*cw*ee**2d0/(4d0*sw**2d0) + cima*ee**2d0/(4d0*cw)
      coupl(nGC_37) = -cima*cw*ee**2d0/(2d0*sw**2d0) - cima*ee**2d0/(2d0*cw)
      coupl(nGC_36) = cima*cw*ee**2d0/(4d0*sw**2d0) + cima*ee**2d0/(4d0*cw)
      coupl(nGC_144) = sqrt(2d0)*yt/2d0
      coupl(nGC_9304) = ee**2d0/(2d0*cw**2d0)
      coupl(nGC_147) = -sqrt(2d0)*cima*ytau/2d0
      coupl(nGC_9269) = -cima*ee*sw/cw**2d0
      coupl(nGC_9268) = cima*ee/cw
      coupl(nGC_9300) = 2d0*cima*ee**2d0
      coupl(nGC_9301) = -4d0*cima*ee**2d0
      coupl(nGC_9265) = -2d0*cima*ee/(3d0*cw)
      coupl(nGC_9264) = -2d0*cima*ee*sw/(3d0*cw)
      coupl(nGC_9267) = cima*ee*sw/cw
      coupl(nGC_9266) = 2d0*cima*ee*sw/(3d0*cw**2d0)
      coupl(nGC_9309) = cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw**2d0*sw)
      coupl(nGC_9307) = cima*ee*(3d0*cw**2d0 - sw**2d0)/(6d0*cw*sw)
      coupl(nGC_9069) = -cima*cw*ee/sw**2d0
      coupl(nGC_9068) = cima*cw*ee/sw
      coupl(nGC_9067) = -3d0*cima/2d0
      coupl(nGC_9066) = -cima/2d0
      coupl(nGC_9075) = -cima*ee**2d0*(cw**2d0 + sw**2d0)/(cw*sw**2d0)
      coupl(nGC_9206) = -ee**2d0/sw
      coupl(nGC_9287) = cima*ee
      coupl(nGC_9286) = -cima*ee**2d0*(cw**2d0 + sw**2d0)**2d0/(2d0*cw**2d0*sw &
                        **2d0)
      coupl(nGC_9284) = -cima*ee**2d0*vev*(cw**2d0 + sw**2d0)**2d0/(cw**2d0*sw &
                        **2d0)
      coupl(nGC_9283) = cima*ee**2d0*vev*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0&
                        )/(cw**2d0*sw**3d0)
      coupl(nGC_9289) = -3d0*cima*lam/2d0
      coupl(nGC_9288) = -3d0*cima*vev/2d0
      coupl(nGC_115) = -cima*ee**2d0*vev/(2d0*sw**2d0) - cima*lam*vev/2d0
      coupl(nGC_9162) = 4d0*cima*ee**2d0/sw**3d0
      coupl(nGC_9163) = cima*ee**2d0/sw**2d0
      coupl(nGC_9160) = cima*ee**2d0/(2d0*sw)
      coupl(nGC_9161) = -4d0*cima*ee**2d0/sw**2d0
      coupl(nGC_9164) = -cima*ee**2d0/sw**3d0
      coupl(nGC_67) = -ee**2d0/sw
      coupl(nGC_9198) = 2d0*cima*ee**2d0/sw**2d0
      coupl(nGC_9197) = -sqrt(2d0)/2d0
      coupl(nGC_MH) = -cMH**2d0*cima
      coupl(nGC_MM) = -cMM*cima
      coupl(nGC_MC) = -cMC*cima
      coupl(nGC_61) = ee/(2d0*sw)
      coupl(nGC_ME) = -cME*cima
      coupl(nGC_MD) = -cMD*cima
      coupl(nGC_MS) = -cMS*cima
      coupl(nGC_MW) = cMW**2d0*cima
      coupl(nGC_9094) = cima*ee**2d0*vev/sw**2d0
      coupl(nGC_MU) = -cMU*cima
      coupl(nGC_124) = -cima*yb
      coupl(nGC_145) = -cima*ytau
      coupl(nGC_9115) = -2d0*cima*cw*ee/sw**2d0
      coupl(nGC_125) = -sqrt(2d0)*yb/2d0
      coupl(nGC_9202) = 2d0*cima*cw*ee/sw**2d0
      coupl(nGC_9110) = cima*ee*(cw - sw)*(cw + sw)/(2d0*cw**2d0*sw)
      coupl(nGC_63) = -cima*cw*ee/sw
      coupl(nGC_9209) = -sqrt(2d0)/2d0
      coupl(nGC_9205) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9308) = -cima*ee*(3d0*cw**2d0 + sw**2d0)/(6d0*cw*sw**2d0)
      coupl(nGC_9203) = -2d0*cima*ee/sw
      coupl(nGC_9200) = -sqrt(2d0)*cima/2d0
      coupl(nGC_9114) = 2d0*cima*cw*ee/sw
      coupl(nGC_34) = -cw*ee**2d0/(4d0*sw**2d0) + ee**2d0/(4d0*cw)
      coupl(nGC_9201) = -2d0*cima*cw*ee/sw
      coupl(nGC_112) = -cima*ee**2d0*vev/sw
      coupl(nGC_MTA) = -cMTA*cima
      coupl(nGC_9260) = -cima*ee*sw/(3d0*cw**2d0)
      coupl(nGC_9240) = 2d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_88) = cima*cw*ee**2d0/(2d0*sw) - cima*ee**2d0*sw/(2d0*cw)
      coupl(nGC_139) = -cima*ys
      coupl(nGC_80) = cima*ee*sw/cw
      coupl(nGC_81) = -cw*ee/(2d0*sw) - ee*sw/(2d0*cw)
      coupl(nGC_82) = -cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
      coupl(nGC_83) = cima*cw*ee/(2d0*sw) - cima*ee*sw/(6d0*cw)
      coupl(nGC_84) = cima*cw*ee/(2d0*sw) - cima*ee*sw/(2d0*cw)
      coupl(nGC_85) = -cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
      coupl(nGC_86) = cima*cw*ee/(2d0*sw) + cima*ee*sw/(2d0*cw)
      coupl(nGC_87) = cw*ee/(2d0*sw) + ee*sw/(2d0*cw)
      coupl(nGC_9306) = -sqrt(2d0)*cima*ee/(2d0*sw**2d0)
      coupl(nGC_9251) = cima*ee**2d0*(cw - sw)*(cw + sw)*(cw**2d0 + sw**2d0)/( &
                        cw**3d0*sw**2d0)
      coupl(nGC_111) = cima*ee**2d0*vev/(2d0*sw)
      coupl(nGC_66) = 2d0*cima*cw*ee/sw
      coupl(nGC_64) = cima*cw*ee/sw
      coupl(nGC_65) = -2d0*cima*cw*ee/sw
      coupl(nGC_62) = sqrt(2d0)*cima*ee/(2d0*sw)
      coupl(nGC_60) = cima*ee/(2d0*sw)
      coupl(nGC_116) = -cima*ee**2d0*vev/(2d0*sw**2d0) - cima*lam*vev/2d0 -    &
                       cima*ee**2d0*vev/(2d0*cw**2d0)
      coupl(nGC_9302) = 4d0*cima*ee**2d0
      coupl(nGC_1752) = -coupl(nGC_59)
      coupl(nGC_9303) = -ee**2d0/cw
      coupl(nGC_9237) = -2d0*cima*cw**2d0*ee**2d0/sw**2d0
      coupl(nGC_114) = cima*ee**2d0*vev/(4d0*sw**2d0) - cima*lam*vev/2d0 + cima&
                       *ee**2d0*vev/(4d0*cw**2d0)
      coupl(nGC_142) = cima*yt
      coupl(nGC_9230) = cima*ee**2d0/sw
      coupl(nGC_110) = -cima*ee**2d0*vev/(2d0*sw)
      coupl(nGC_113) = cima*ee**2d0*vev/(4d0*sw**2d0) - cima*lam*vev/2d0
      coupl(nGC_143) = -sqrt(2d0)*cima*yt/2d0
      coupl(nGC_9238) = 2d0*cima*cw**2d0*ee**2d0/sw**3d0
      coupl(nGC_9239) = -2d0*cima*cw*ee**2d0/sw**2d0
      coupl(nGC_374) = -coupl(nGC_61)
      coupl(nGC_470) = coupl(nGC_50)/2d0
      coupl(nGC_472) = -coupl(nGC_50)
      coupl(nGC_1446) = -coupl(nGC_150)
      coupl(nGC_1048) = -coupl(nGC_146)
      coupl(nGC_2148) = -coupl(nGC_60)
      coupl(nGC_398) = -coupl(nGC_64)
      coupl(nGC_394) = -coupl(nGC_85)
      coupl(nGC_308) = -coupl(nGC_140)
      coupl(nGC_674) = -coupl(nGC_134)
      coupl(nGC_1832) = -coupl(nGC_125)
      coupl(nGC_248) = -coupl(nGC_144)
      coupl(nGC_2266) = -coupl(nGC_63)
      coupl(nGC_1206) = -coupl(nGC_81)
    end subroutine fill_couplings_mdl1
end module fill_couplings1
