!******************************************************************************!
!                                                                              !
!    fill_ctcouplings1.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings1.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_CTcouplings_mdl1()
      coupl(nGC_9728) = coupl(nGC_9261)*dZee_QED2 + coupl(nGC_9262)*dcw_QED2 + &
                        coupl(nGC_9263)*dvev_QED1
      coupl(nGC_9687) = -cima*dytau_QED3
      coupl(nGC_9686) = -cima*dym_QED3
      coupl(nGC_9685) = -cima*dye_QED3
      coupl(nGC_GG) = cima*dt_QED1/vev
      coupl(nGC_9750) = -cima*dMTA_QED2
      coupl(nGC_9752) = -cima*dMU_QCD2
      coupl(nGC_14125) = coupl(nGC_128)*(dZcL_QED2 + dZcR_QED2)/2d0
      coupl(nGC_GGH) = -cima*dt_QED1/vev**2d0
      coupl(nGC_9751) = -cima*dMU_QED2
      coupl(nGC_9763) = cima*dMZ2_QED2
      coupl(nGC_HHGG) = -cima*dt_QED1/vev**3d0
      coupl(nGC_9712) = coupl(nGC_9279)*dZee_QED2
      coupl(nGC_17544) = coupl(nGC_MI)*dZdL_QCD2
      coupl(nGC_17549) = coupl(nGC_MI)*dZdR_QED2
      coupl(nGC_15695) = coupl(nGC_123)*dZZA_QED2/2d0
      coupl(nGC_9706) = coupl(nGC_9296)*dZee_QED2
      coupl(nGC_9757) = -cima*dMD_QED2
      coupl(nGC_9705) = coupl(nGC_9220)*dyt_QED3
      coupl(nGC_9661) = cima*dyup_QED1_QCD2
      coupl(nGC_9663) = -cima*dydo_QED1_QCD2
      coupl(nGC_9662) = cima*dyup_QED3
      coupl(nGC_9665) = -cima*dys_QED1_QCD2
      coupl(nGC_9667) = cima*dyc_QED1_QCD2
      coupl(nGC_17550) = coupl(nGC_MI)*dZdR_QCD2
      coupl(nGC_15333) = coupl(nGC_19)*dZcR_QCD2
      coupl(nGC_9668) = cima*dyc_QED3
      coupl(nGC_15330) = coupl(nGC_19)*dZcL_QED2
      coupl(nGC_14139) = coupl(nGC_19)*dZuL_QED2
      coupl(nGC_9759) = -cima*dMS_QED2
      coupl(nGC_9758) = -cima*dMD_QCD2
      coupl(nGC_9447) = coupl(nGC_131)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_9443) = coupl(nGC_129)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_14874) = coupl(nGC_MT)*(dZtL_QCD2 + dZtR_QCD2)/2d0
      coupl(nGC_15997) = coupl(nGC_MI)*dZcR_QCD2
      coupl(nGC_15996) = coupl(nGC_MI)*dZcR_QED2
      coupl(nGC_15991) = coupl(nGC_MI)*dZcL_QCD2
      coupl(nGC_15990) = coupl(nGC_MI)*dZcL_QED2
      coupl(nGC_9696) = coupl(nGC_9204)*dyc_QED1_QCD2
      coupl(nGC_9697) = coupl(nGC_9204)*dyc_QED3
      coupl(nGC_14873) = coupl(nGC_MT)*(dZtL_QED2 + dZtR_QED2)/2d0
      coupl(nGC_15790) = coupl(nGC_MI)*dZeMinusR_QED2
      coupl(nGC_9366) = cima*coupl(nGC_19)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 &
                         - cMD**2d0 - cMS**2d0 - cMT**2d0 - cMU**2d0)/(16d0*pi &
                        **2d0*Nc)
      coupl(nGC_14878) = coupl(nGC_MI)*dZtR_QCD2
      coupl(nGC_15157) = coupl(nGC_MI)*dZA_QED2
      coupl(nGC_15096) = coupl(nGC_19)*dZbL_QED2
      coupl(nGC_15097) = coupl(nGC_19)*dZbL_QCD2
      coupl(nGC_15095) = coupl(nGC_19)*dZbR_QCD2
      coupl(nGC_14578) = coupl(nGC_141)*(dZsL_QED2 + dZsR_QED2)/2d0
      coupl(nGC_14579) = coupl(nGC_141)*(dZsL_QCD2 + dZsR_QCD2)/2d0
      coupl(nGC_9363) = cima*coupl(nGC_19)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0  &
                         + cMD**2d0 + cMS**2d0 + cMT**2d0 + cMU**2d0)/(16d0*pi &
                        **2d0)
      coupl(nGC_15158) = -coupl(nGC_15157)
      coupl(nGC_14174) = coupl(nGC_2)*dZuL_QCD2
      coupl(nGC_15094) = coupl(nGC_19)*dZbR_QED2
      coupl(nGC_9748) = -cima*dME_QED2
      coupl(nGC_9749) = -cima*dMM_QED2
      coupl(nGC_9741) = coupl(nGC_9297)*dZee_QED2 + coupl(nGC_9298)*dsw_QED2 + &
                        coupl(nGC_9299)*dcw_QED2
      coupl(nGC_17192) = coupl(nGC_MI)*dZmuMinusL_QED2
      coupl(nGC_9370) = cMS*cima*coupl(nGC_19)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_9702) = coupl(nGC_9077)*dyc_QED1_QCD2
      coupl(nGC_18817) = coupl(nGC_MI)*dZsL_QED2
      coupl(nGC_18818) = coupl(nGC_MI)*dZsL_QCD2
      coupl(nGC_16909) = coupl(nGC_MI)*dZnu_muL_QED2
      coupl(nGC_14203) = coupl(nGC_131)*(dZdL_QCD2 + dZdR_QCD2)/2d0
      coupl(nGC_17194) = coupl(nGC_MI)*dZmuMinusR_QED2
      coupl(nGC_HHHH) = -3d0*cima*dt_QED1/vev**3d0
      coupl(nGC_9415) = coupl(nGC_127)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_13971) = coupl(nGC_1)*dZbL_QCD2
      coupl(nGC_15051) = coupl(nGC_2)*dZAZ_QED2/2d0
      coupl(nGC_9765) = coupl(nGC_206)*dMW2_QED2
      coupl(nGC_13958) = coupl(nGC_96)*dZZA_QED2/2d0
      coupl(nGC_9381) = coupl(nGC_1)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 - 1d0&
                        )/(32d0*pi**2d0*Nc)
      coupl(nGC_14171) = coupl(nGC_2)*dZuR_QCD2
      coupl(nGC_9703) = coupl(nGC_9077)*dyc_QED3
      coupl(nGC_14630) = coupl(nGC_77)*dZAZ_QED2
      coupl(nGC_14736) = coupl(nGC_126)*(dZbL_QED2 + dZbR_QED2)/2d0
      coupl(nGC_14737) = coupl(nGC_126)*(dZbL_QCD2 + dZbR_QCD2)/2d0
      coupl(nGC_9673) = coupl(nGC_9157)*dydo_QED1_QCD2
      coupl(nGC_15605) = coupl(nGC_135)*(dZeMinusL_QED2 + dZeMinusR_QED2)/2d0
      coupl(nGC_14126) = coupl(nGC_128)*(dZcL_QCD2 + dZcR_QCD2)/2d0
      coupl(nGC_20004) = coupl(nGC_MI)*dZg_QCD2
      coupl(nGC_9674) = coupl(nGC_9157)*dydo_QED3
      coupl(nGC_9672) = cima*dyt_QED3
      coupl(nGC_14872) = coupl(nGC_MI)*dZtL_QCD2
      coupl(nGC_9670) = -cima*dyb_QED3
      coupl(nGC_14303) = coupl(nGC_1)*dZAZ_QED2/2d0
      coupl(nGC_16846) = coupl(nGC_2)*dZtL_QCD2
      coupl(nGC_16849) = coupl(nGC_2)*dZtR_QCD2
      coupl(nGC_9717) = coupl(nGC_9178)*dZee_QED2 + coupl(nGC_9179)*dsw_QED2 + &
                        coupl(nGC_9180)*dcw_QED2
      coupl(nGC_9746) = -cima*dMH2_QED2
      coupl(nGC_9708) = coupl(nGC_9170)*dZee_QED2 + coupl(nGC_9171)*dsw_QED2
      coupl(nGC_14998) = coupl(nGC_19)*dZsR_QCD2
      coupl(nGC_14999) = coupl(nGC_19)*dZsL_QED2
      coupl(nGC_14871) = coupl(nGC_MI)*dZtL_QED2
      coupl(nGC_9474) = coupl(nGC_128)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_14393) = coupl(nGC_77)*dZZA_QED2
      coupl(nGC_GPGMGPGM) = -2d0*cima*dt_QED1/vev**3d0
      coupl(nGC_14541) = coupl(nGC_19)*dZdL_QCD2
      coupl(nGC_14540) = coupl(nGC_19)*dZdL_QED2
      coupl(nGC_16026) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
      coupl(nGC_14997) = coupl(nGC_19)*dZsR_QED2
      coupl(nGC_14877) = coupl(nGC_MI)*dZtR_QED2
      coupl(nGC_16028) = coupl(nGC_MI)*dZbR_QCD2
      coupl(nGC_14264) = coupl(nGC_129)*(dZcL_QED2 + dZcR_QED2)/2d0
      coupl(nGC_9372) = cMT*cima*coupl(nGC_19)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_17164) = coupl(nGC_MI)*dZtauMinusR_QED2
      coupl(nGC_17161) = coupl(nGC_MI)*dZtauMinusL_QED2
      coupl(nGC_9357) = cMD*cima*coupl(nGC_19)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_9588) = cima*coupl(nGC_19)**2d0*sq2**2d0*(-coupl(nGC_1)**2d0 - &
                        coupl(nGC_2)**2d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_15310) = coupl(nGC_146)*(dZtauMinusL_QED2 + dZtauMinusR_QED2)/ &
                         2d0
      coupl(nGC_9587) = cima*coupl(nGC_19)**2d0*sq2**2d0*(coupl(nGC_1)**2d0 +  &
                        coupl(nGC_2)**2d0)/(16d0*pi**2d0)
      coupl(nGC_9632) = coupl(nGC_9090)*dZee_QED2 + coupl(nGC_9091)*dsw_QED2 + &
                        coupl(nGC_9092)*dcw_QED2
      coupl(nGC_9630) = cima*coupl(nGC_19)**4d0*sq2**4d0/(32d0*pi**2d0*Nc**2d0)
      coupl(nGC_9636) = coupl(nGC_9099)*dZee_QED2 + coupl(nGC_9100)*dsw_QED2 + &
                        coupl(nGC_9101)*dcw_QED2
      coupl(nGC_9637) = coupl(nGC_9313)*dZee_QED2 + coupl(nGC_9314)*dcw_QED2
      coupl(nGC_9737) = coupl(nGC_174)*dZgs_QCD2
      coupl(nGC_9736) = coupl(nGC_9274)*dZee_QED2
      coupl(nGC_9734) = coupl(nGC_9255)*dZee_QED2 + coupl(nGC_9256)*dsw_QED2 + &
                        coupl(nGC_9257)*dcw_QED2
      coupl(nGC_9704) = coupl(nGC_9220)*dyt_QED1_QCD2
      coupl(nGC_18821) = coupl(nGC_MI)*dZsR_QED2
      coupl(nGC_18822) = coupl(nGC_MI)*dZsR_QCD2
      coupl(nGC_14802) = coupl(nGC_1)*dZdR_QCD2
      coupl(nGC_9645) = coupl(nGC_9210)*dZee_QED2 + coupl(nGC_9211)*dsw_QED2
      coupl(nGC_9642) = coupl(nGC_9214)*dZee_QED2 + coupl(nGC_9215)*dsw_QED2
      coupl(nGC_9641) = coupl(nGC_9152)*dZee_QED2 + coupl(nGC_9153)*dsw_QED2
      coupl(nGC_9640) = -cima*dlam_QED4
      coupl(nGC_9648) = coupl(nGC_9123)*dlam_QED4 + coupl(nGC_9124)*dvev_QED1
      coupl(nGC_14330) = coupl(nGC_19)*dZtR_QCD2
      coupl(nGC_14331) = coupl(nGC_19)*dZtL_QED2
      coupl(nGC_14332) = coupl(nGC_19)*dZtL_QCD2
      coupl(nGC_16781) = coupl(nGC_MI)*dZuL_QCD2
      coupl(nGC_16780) = coupl(nGC_MI)*dZuL_QED2
      coupl(nGC_16785) = coupl(nGC_MI)*dZuR_QCD2
      coupl(nGC_16784) = coupl(nGC_MI)*dZuR_QED2
      coupl(nGC_16023) = coupl(nGC_MI)*dZbL_QED2
      coupl(nGC_16027) = coupl(nGC_MI)*dZbR_QED2
      coupl(nGC_16024) = coupl(nGC_MI)*dZbL_QCD2
      coupl(nGC_16025) = coupl(nGC_MB)*(dZbL_QED2 + dZbR_QED2)/2d0
      coupl(nGC_9629) = (-Nc*cima*coupl(nGC_1160)**4d0*sq2**4d0 + 6d0*Nc*cima* &
                        coupl(nGC_1570)*coupl(nGC_20) - 6d0*Nc*coupl(nGC_1160  &
                        )**2d0*coupl(nGC_1570)*sq2**2d0 + 9d0*cima*coupl(nGC_19&
                        )**4d0*sq2**4d0)/(192d0*pi**2d0)
      coupl(nGC_14265) = coupl(nGC_129)*(dZcL_QCD2 + dZcR_QCD2)/2d0
      coupl(nGC_HHH) = -3d0*cima*dt_QED1/vev**2d0
      coupl(nGC_14807) = coupl(nGC_1)*dZdR_QED2 + coupl(nGC_78)*dZZA_QED2/2d0
      coupl(nGC_9465) = coupl(nGC_150)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_9549) = coupl(nGC_19)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(       &
                        nGC_1160) - 2d0*coupl(nGC_19))/(128d0*pi**2d0*Nc)
      coupl(nGC_9546) = coupl(nGC_19)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(      &
                        nGC_1160) + 2d0*coupl(nGC_19))/(128d0*pi**2d0*Nc**2d0)
      coupl(nGC_9543) = -coupl(nGC_19)*sq2*(4d0*coupl(nGC_1)**2d0 + coupl(     &
                        nGC_130)**2d0 + coupl(nGC_131)*coupl(nGC_574) + coupl( &
                        nGC_132)**2d0 + 4d0*coupl(nGC_78)**2d0)/(64d0*pi**2d0* &
                        Nc)
      coupl(nGC_14306) = coupl(nGC_78)*dZdR_QCD2
      coupl(nGC_14788) = coupl(nGC_140)*(dZsL_QCD2 + dZsR_QCD2)/2d0
      coupl(nGC_9753) = -cima*dMC_QED2
      coupl(nGC_17543) = coupl(nGC_MI)*dZdL_QED2
      coupl(nGC_9541) = -coupl(nGC_19)*sq2*(-4d0*coupl(nGC_1)**2d0 - coupl(    &
                        nGC_130)**2d0 - coupl(nGC_131)*coupl(nGC_574) - coupl( &
                        nGC_132)**2d0 - 4d0*coupl(nGC_78)**2d0)/(64d0*pi**2d0)
      coupl(nGC_14136) = coupl(nGC_MZ_GF)*dZZA_QED2/2d0
      coupl(nGC_17521) = coupl(nGC_144)*(dZtL_QCD2 + dZtR_QCD2)/2d0
      coupl(nGC_15331) = coupl(nGC_19)*dZcL_QCD2
      coupl(nGC_9664) = -cima*dydo_QED3
      coupl(nGC_14724) = coupl(nGC_127)*dZcR_QED2/2d0 + coupl(nGC_127)*        &
                         dZsL_QED2/2d0 + coupl(nGC_9668)
      coupl(nGC_15419) = coupl(nGC_1)*dZsR_QCD2
      coupl(nGC_15414) = coupl(nGC_1)*dZsL_QCD2
      coupl(nGC_9666) = -cima*dys_QED3
      coupl(nGC_9669) = -cima*dyb_QED1_QCD2
      coupl(nGC_15332) = coupl(nGC_19)*dZcR_QED2
      coupl(nGC_16210) = coupl(nGC_78)*dZsR_QCD2
      coupl(nGC_14099) = coupl(nGC_I)*dZH_QED2
      coupl(nGC_9764) = cima*dMW2_QED2
      coupl(nGC_9766) = coupl(nGC_210)*dMW2_QED2
      coupl(nGC_9760) = -cima*dMS_QCD2
      coupl(nGC_9761) = -cima*dMB_QED2
      coupl(nGC_9762) = -cima*dMB_QCD2
      coupl(nGC_16852) = coupl(nGC_2)*dZtR_QED2 + coupl(nGC_79)*dZZA_QED2/2d0
      coupl(nGC_14143) = coupl(nGC_19)*dZuR_QED2
      coupl(nGC_14076) = coupl(nGC_57)*dZZ_QED2 + coupl(nGC_76)*dZAZ_QED2 +    &
                         coupl(nGC_9717)
      coupl(nGC_19748) = coupl(nGC_9763) + coupl(nGC_MZ)*dZZ_QED2
      coupl(nGC_14985) = coupl(nGC_78)*dZbR_QCD2
      coupl(nGC_17215) = coupl(nGC_149)*(dZuL_QED2 + dZuR_QED2)/2d0
      coupl(nGC_19745) = coupl(nGC_MI)*dZZ_QED2
      coupl(nGC_9618) = cima*coupl(nGC_19)**3d0*sq2**3d0*(coupl(nGC_1) + coupl(&
                        nGC_2))/(16d0*pi**2d0*Nc**2d0)
      coupl(nGC_13968) = coupl(nGC_1)*dZbR_QCD2
      coupl(nGC_9623) = (-Nc*cima*coupl(nGC_1160)**4d0*sq2**4d0 + 3d0*Nc*cima* &
                        coupl(nGC_1570)**2d0 + 3d0*Nc*cima*coupl(nGC_20)**2d0  &
                         - 3d0*Nc*coupl(nGC_1160)**2d0*coupl(nGC_1570)*sq2**2d0&
                         - 3d0*Nc*coupl(nGC_1160)**2d0*coupl(nGC_20)*sq2**2d0  &
                         + 9d0*cima*coupl(nGC_19)**4d0*sq2**4d0)/(192d0*pi**2d0&
                        )
      coupl(nGC_9754) = -cima*dMC_QCD2
      coupl(nGC_14202) = coupl(nGC_131)*(dZdL_QED2 + dZdR_QED2)/2d0
      coupl(nGC_9756) = -cima*dMT_QCD2
      coupl(nGC_14204) = -coupl(nGC_14203) - coupl(nGC_9673)
      coupl(nGC_14205) = coupl(nGC_14203) + coupl(nGC_9673)
      coupl(nGC_14206) = -coupl(nGC_14202) - coupl(nGC_9674)
      coupl(nGC_14207) = coupl(nGC_14202) + coupl(nGC_9674)
      coupl(nGC_15000) = coupl(nGC_19)*dZsL_QCD2
      coupl(nGC_14087) = coupl(nGC_137)*(dZmuMinusL_QED2 + dZmuMinusR_QED2)/2d0
      coupl(nGC_14805) = coupl(nGC_1)*dZdL_QCD2
      coupl(nGC_14933) = coupl(nGC_101)*dZH_QED2/2d0 + coupl(nGC_9648) + coupl(&
                         nGC_GGH)
      coupl(nGC_9767) = coupl(nGC_214)*dMZ2_QED2
      coupl(nGC_9617) = cima*coupl(nGC_19)**3d0*sq2**3d0*(-coupl(nGC_1) - coupl&
                        (nGC_2))/(32d0*pi**2d0*Nc)
      coupl(nGC_14787) = coupl(nGC_140)*(dZsL_QED2 + dZsR_QED2)/2d0
      coupl(nGC_14851) = coupl(nGC_MI)*dZWMinus_QED2
      coupl(nGC_14854) = coupl(nGC_9764) + coupl(nGC_MW)*dZWMinus_QED2
      coupl(nGC_9439) = coupl(nGC_125)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_9729) = coupl(nGC_9252)*dZee_QED2 + coupl(nGC_9253)*dsw_QED2 + &
                        coupl(nGC_9254)*dcw_QED2
      coupl(nGC_15072) = coupl(nGC_150)*(dZuL_QCD2 + dZuR_QCD2)/2d0
      coupl(nGC_17520) = coupl(nGC_144)*(dZtL_QED2 + dZtR_QED2)/2d0
      coupl(nGC_9755) = -cima*dMT_QED2
      coupl(nGC_9338) = (2d0*Nc*cMB**2d0*cima*coupl(nGC_1)**2d0 + 2d0*Nc*cMC** &
                        2d0*cima*coupl(nGC_2)**2d0 + 2d0*Nc*cMD**2d0*cima*coupl&
                        (nGC_1)**2d0 + 2d0*Nc*cMS**2d0*cima*coupl(nGC_1)**2d0  &
                         + 2d0*Nc*cMT**2d0*cima*coupl(nGC_2)**2d0 + 2d0*Nc*cMU &
                        **2d0*cima*coupl(nGC_2)**2d0 + 2d0*cME**2d0*cima*coupl(&
                        nGC_4)**2d0 + 2d0*cMM**2d0*cima*coupl(nGC_4)**2d0 + 2d0&
                        *cMTA**2d0*cima*coupl(nGC_4)**2d0 + cMW**2d0*cima*coupl&
                        (nGC_3)**2d0 + cMW**2d0*cima*coupl(nGC_746)**2d0 - cMW &
                        **2d0*coupl(nGC_9))/(8d0*pi**2d0)
      coupl(nGC_14808) = coupl(nGC_1)*dZdL_QED2 + coupl(nGC_82)*dZZA_QED2/2d0
      coupl(nGC_9364) = cima*sq2**2d0*(-Nc*coupl(nGC_1160)**2d0 + 6d0*coupl(   &
                        nGC_19)**2d0)/(96d0*pi**2d0*Nc)
      coupl(nGC_9671) = cima*dyt_QED1_QCD2
      coupl(nGC_20005) = -coupl(nGC_20004)
      coupl(nGC_14756) = coupl(nGC_9767) + coupl(nGC_MZ_GF)*dZZ_QED2/2d0
      coupl(nGC_9480) = coupl(nGC_138)*(-coupl(nGC_137)**2d0 - coupl(nGC_138)**&
                        2d0 + 8d0*coupl(nGC_4)**2d0 + 8d0*coupl(nGC_80)*coupl( &
                        nGC_85))/(32d0*pi**2d0)
      coupl(nGC_9483) = (8d0*coupl(nGC_1)**2d0*coupl(nGC_141) - coupl(nGC_127)*&
                        coupl(nGC_128)*coupl(nGC_139) - coupl(nGC_140)**2d0*   &
                        coupl(nGC_141) - coupl(nGC_141)**3d0 + 8d0*coupl(      &
                        nGC_141)*coupl(nGC_78)*coupl(nGC_82))/(32d0*pi**2d0)
      coupl(nGC_9484) = coupl(nGC_141)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_9339) = cima*(Nc*coupl(nGC_126)**2d0 + Nc*coupl(nGC_128)**2d0  &
                         + Nc*coupl(nGC_132)**2d0 + Nc*coupl(nGC_141)**2d0 + Nc&
                        *coupl(nGC_143)**2d0 + Nc*coupl(nGC_149)**2d0 + coupl( &
                        nGC_135)**2d0 + coupl(nGC_138)**2d0 + coupl(nGC_147)** &
                        2d0)/(24d0*pi**2d0)
      coupl(nGC_9337) = cima*(coupl(nGC_3)**2d0 + coupl(nGC_746)**2d0)/(48d0*pi&
                        **2d0)
      coupl(nGC_9336) = cima*(-6d0*Nc*coupl(nGC_1)**2d0 - 6d0*Nc*coupl(nGC_2)**&
                        2d0 - coupl(nGC_3)**2d0 - 6d0*coupl(nGC_4)**2d0 - coupl&
                        (nGC_746)**2d0)/(48d0*pi**2d0)
      coupl(nGC_9335) = (-Nc*cMB**2d0*cima*coupl(nGC_124)**2d0 - Nc*cMB**2d0*  &
                        cima*coupl(nGC_142)**2d0 - Nc*cMC**2d0*cima*coupl(     &
                        nGC_127)**2d0 - Nc*cMC**2d0*cima*coupl(nGC_139)**2d0 - &
                        Nc*cMD**2d0*cima*coupl(nGC_130)**2d0 - Nc*cMD**2d0*cima&
                        *coupl(nGC_148)**2d0 - Nc*cMS**2d0*cima*coupl(nGC_127  &
                        )**2d0 - Nc*cMS**2d0*cima*coupl(nGC_139)**2d0 - Nc*cMT &
                        **2d0*cima*coupl(nGC_124)**2d0 - Nc*cMT**2d0*cima*coupl&
                        (nGC_142)**2d0 - Nc*cMU**2d0*cima*coupl(nGC_130)**2d0  &
                         - Nc*cMU**2d0*cima*coupl(nGC_148)**2d0 - cME**2d0*cima&
                        *coupl(nGC_133)**2d0 - cMM**2d0*cima*coupl(nGC_136)**  &
                        2d0 - cMTA**2d0*cima*coupl(nGC_145)**2d0 - 2d0*cMW**2d0&
                        *coupl(nGC_47) - cMZ**2d0*coupl(nGC_95) + 2d0*cima*    &
                        coupl(nGC_110)**2d0 + 2d0*cima*coupl(nGC_99)**2d0)/(   &
                        16d0*pi**2d0)
      coupl(nGC_9334) = cima*(Nc*coupl(nGC_124)**2d0 + Nc*coupl(nGC_127)**2d0  &
                         + Nc*coupl(nGC_130)**2d0 + Nc*coupl(nGC_139)**2d0 + Nc&
                        *coupl(nGC_142)**2d0 + Nc*coupl(nGC_148)**2d0 + coupl( &
                        nGC_133)**2d0 + coupl(nGC_136)**2d0 + coupl(nGC_145)** &
                        2d0)/(48d0*pi**2d0)
      coupl(nGC_9333) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_78)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_9332) = cMB*cima*coupl(nGC_19)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_9331) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_62)**2d0 - coupl( &
                        nGC_82)**2d0)/(16d0*pi**2d0)
      coupl(nGC_9330) = cima*coupl(nGC_19)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(64d0&
                        *pi**2d0*Nc)
      coupl(nGC_14035) = coupl(nGC_77)*dZA_QED2/2d0 + coupl(nGC_77)*           &
                         dZWMinus_QED2 + coupl(nGC_77)*dZZ_QED2/2d0 + coupl(   &
                         nGC_9729)
      coupl(nGC_14034) = coupl(nGC_56)*dZZA_QED2/2d0
      coupl(nGC_14033) = coupl(nGC_55)*dZZA_QED2/2d0
      coupl(nGC_14030) = coupl(nGC_8)*dZAZ_QED2/2d0
      coupl(nGC_14538) = coupl(nGC_19)*dZdR_QED2
      coupl(nGC_14539) = coupl(nGC_19)*dZdR_QCD2
      coupl(nGC_16224) = coupl(nGC_MI)*dZZA_QED2/2d0
      coupl(nGC_16225) = coupl(nGC_MZ)*dZZA_QED2/2d0
      coupl(nGC_14559) = coupl(nGC_4)*dZAZ_QED2/2d0
      coupl(nGC_9654) = coupl(nGC_9295)*dZee_QED2
      coupl(nGC_9655) = coupl(nGC_9287)*dZee_QED2
      coupl(nGC_9656) = coupl(nGC_9114)*dZee_QED2 + coupl(nGC_9115)*dsw_QED2 + &
                        coupl(nGC_9116)*dcw_QED2
      coupl(nGC_9657) = coupl(nGC_9201)*dZee_QED2 + coupl(nGC_9202)*dsw_QED2 + &
                        coupl(nGC_9203)*dcw_QED2
      coupl(nGC_9650) = coupl(nGC_9141)*dsw_QED2 + coupl(nGC_9142)*dZee_QED2 + &
                        coupl(nGC_9143)*dvev_QED1
      coupl(nGC_9651) = coupl(nGC_9158)*dsw_QED2 + coupl(nGC_9159)*dZee_QED2 + &
                        coupl(nGC_9160)*dvev_QED1
      coupl(nGC_9652) = coupl(nGC_9302)*dZee_QED2
      coupl(nGC_9653) = coupl(nGC_9294)*dZee_QED2
      coupl(nGC_13983) = coupl(nGC_147)*(dZtauMinusL_QED2 + dZtauMinusR_QED2)/ &
                         2d0
      coupl(nGC_9658) = coupl(nGC_9318)*dZgs_QCD2
      coupl(nGC_9659) = coupl(nGC_9322)*dZgs_QCD2
      coupl(nGC_14329) = coupl(nGC_19)*dZtR_QED2
      coupl(nGC_14248) = coupl(nGC_110)*dZAZ_QED2/2d0 + coupl(nGC_9728) + coupl&
                         (nGC_99)*dZWMinus_QED2/2d0 + coupl(nGC_99)*dZZ_QED2/  &
                         2d0
      coupl(nGC_16030) = coupl(nGC_16026) + coupl(nGC_9762)
      coupl(nGC_9427) = (8d0*coupl(nGC_1)*coupl(nGC_124)*coupl(nGC_2) + 8d0*   &
                        coupl(nGC_124)*coupl(nGC_78)*coupl(nGC_83) - coupl(    &
                        nGC_125)*coupl(nGC_142)*coupl(nGC_144) - coupl(nGC_126 &
                        )*coupl(nGC_142)*coupl(nGC_143))/(32d0*pi**2d0)
      coupl(nGC_16819) = coupl(nGC_132)*(dZdL_QED2 + dZdR_QED2)/2d0
      coupl(nGC_9426) = coupl(nGC_62)*(Nc*coupl(nGC_124)*coupl(nGC_126) - Nc*  &
                        coupl(nGC_127)*coupl(nGC_128) + Nc*coupl(nGC_130)*coupl&
                        (nGC_132) + Nc*coupl(nGC_139)*coupl(nGC_141) - Nc*coupl&
                        (nGC_142)*coupl(nGC_143) - Nc*coupl(nGC_148)*coupl(    &
                        nGC_149) + coupl(nGC_133)*coupl(nGC_135) + coupl(      &
                        nGC_136)*coupl(nGC_138) + coupl(nGC_145)*coupl(nGC_147 &
                        ))/(24d0*pi**2d0)
      coupl(nGC_9356) = cMD*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_78)*coupl(    &
                        nGC_82))/(8d0*pi**2d0)
      coupl(nGC_9411) = coupl(nGC_124)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_9470) = coupl(nGC_126)*coupl(nGC_19)**2d0*sq2**2d0*(Nc**2d0 -  &
                        1d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_17033) = coupl(nGC_2)*dZcL_QED2 + coupl(nGC_83)*dZZA_QED2/2d0
      coupl(nGC_9472) = (-coupl(nGC_127)*coupl(nGC_139)*coupl(nGC_141) - coupl(&
                        nGC_128)**3d0 + 8d0*coupl(nGC_128)*coupl(nGC_2)**2d0 - &
                        coupl(nGC_128)*coupl(nGC_506)**2d0 + 8d0*coupl(nGC_128 &
                        )*coupl(nGC_79)*coupl(nGC_83))/(32d0*pi**2d0)
      coupl(nGC_17031) = coupl(nGC_2)*dZcR_QCD2
    end subroutine fill_CTcouplings_mdl1
end module fill_ctcouplings1
