!******************************************************************************!
!                                                                              !
!    ctparameter102.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter102.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter102
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter102()
  if (dMM_QED2_scheme .eq. 0) then
    dMM_QED2 = (2d0*Ten290*cMM*coupl(nGC_4)**2d0 + Ten291*cMM*(-coupl(nGC_80)**&
               2d0 + 4d0*coupl(nGC_80)*coupl(nGC_85) - coupl(nGC_85)**2d0) +   &
               Ten292*cMM*coupl(nGC_138)**2d0 - 2d0*Ten293*cMM*coupl(nGC_4)**  &
               2d0 + Ten294*cMM*(coupl(nGC_136)**2d0 + 2d0*coupl(nGC_62)**2d0)/&
               2d0 + Ten295*cMM*(coupl(nGC_137)**2d0 - coupl(nGC_80)**2d0 -    &
               coupl(nGC_85)**2d0) - Ten296*cMM*coupl(nGC_138)**2d0 + 2d0*     &
               Ten297*cMM*coupl(nGC_138)**2d0*rMM*(-cMM + rMM) + 4d0*Ten298*   &
               coupl(nGC_4)**2d0*rMM*(2d0*cMM**2d0 - 3d0*cMM*rMM + rMM**2d0) + &
               2d0*Ten299*rMM*(-cMM**2d0*coupl(nGC_137)**2d0 + 4d0*cMM**2d0*   &
               coupl(nGC_80)*coupl(nGC_85) + 2d0*cMM*coupl(nGC_137)**2d0*rMM - &
               cMM*coupl(nGC_80)**2d0*rMM - 4d0*cMM*coupl(nGC_80)*coupl(nGC_85 &
               )*rMM - cMM*coupl(nGC_85)**2d0*rMM - coupl(nGC_137)**2d0*rMM**  &
               2d0 + coupl(nGC_80)**2d0*rMM**2d0 + coupl(nGC_85)**2d0*rMM**2d0 &
               ) + 2d0*Ten300*coupl(nGC_138)**2d0*rMM**2d0*(cMM - rMM) + 4d0*  &
               Ten301*coupl(nGC_4)**2d0*rMM**2d0*(-cMM + rMM) + Ten302*rMM**2d0&
               *(cMM*coupl(nGC_136)**2d0 + 2d0*cMM*coupl(nGC_62)**2d0 - coupl( &
               nGC_136)**2d0*rMM - 2d0*coupl(nGC_62)**2d0*rMM) + 2d0*Ten303*rMM&
               **2d0*(cMM*coupl(nGC_137)**2d0 - cMM*coupl(nGC_80)**2d0 - cMM*  &
               coupl(nGC_85)**2d0 - coupl(nGC_137)**2d0*rMM + coupl(nGC_80)**  &
               2d0*rMM + coupl(nGC_85)**2d0*rMM) + pi**2d0*(-8d0*aEW*cMM**2d0/(&
               pi*rMM) + 8d0*aEW*rMM/pi - cMM*coupl(nGC_4)**2d0/pi**2d0 + cMM* &
               coupl(nGC_62)**2d0/(2d0*pi**2d0) + cMM*coupl(nGC_80)**2d0/(2d0* &
               pi**2d0) - 2d0*cMM*coupl(nGC_80)*coupl(nGC_85)/pi**2d0 + cMM*   &
               coupl(nGC_85)**2d0/(2d0*pi**2d0)))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMM_QED2 = cone*real(dMM_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter102
end module ctparameter102
