!******************************************************************************!
!                                                                              !
!    ctparameter131.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter131.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter131
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter131()
  if (dMS_QED2_scheme .eq. 0) then
    dMS_QED2 = (2d0*Ten204*cMS*coupl(nGC_1)**2d0 + Ten205*cMS*(-coupl(nGC_78)**&
               2d0 + 4d0*coupl(nGC_78)*coupl(nGC_82) - coupl(nGC_82)**2d0) +   &
               Ten206*(-cMC*coupl(nGC_127)*coupl(nGC_139) - cMS*coupl(nGC_127  &
               )**2d0/2d0 - cMS*coupl(nGC_139)**2d0/2d0 - cMS*coupl(nGC_62)**  &
               2d0) + Ten207*cMS*coupl(nGC_141)**2d0 - 2d0*Ten208*cMS*coupl(   &
               nGC_1)**2d0 + Ten209*cMS*(coupl(nGC_140)**2d0 - coupl(nGC_78)** &
               2d0 - coupl(nGC_82)**2d0) + Ten210*cMS*(-coupl(nGC_127)**2d0 -  &
               coupl(nGC_139)**2d0 - 2d0*coupl(nGC_62)**2d0)/2d0 - Ten211*cMS* &
               coupl(nGC_141)**2d0 + pi**2d0*(-cMS*coupl(nGC_1)**2d0/pi**2d0 + &
               cMS*coupl(nGC_62)**2d0/(2d0*pi**2d0) + cMS*coupl(nGC_78)**2d0/( &
               2d0*pi**2d0) - 2d0*cMS*coupl(nGC_78)*coupl(nGC_82)/pi**2d0 + cMS&
               *coupl(nGC_82)**2d0/(2d0*pi**2d0)))/(16d0*pi**2d0)
    dMS_QED2 = cone*real(dMS_QED2,kind=dp)
  end if 
end subroutine set_ctparameter131
end module ctparameter131
