!******************************************************************************!
!                                                                              !
!    ctparameter34.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter34.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter34
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter34()
  if (dZcR_QCD2_scheme .eq. 0) then
    dZcR_QCD2 = (pi**2d0*(-Nc*coupl(nGC_19)**2d0/(2d0*pi**2d0) + coupl(nGC_19  &
                )**2d0/(2d0*pi**2d0*Nc)) + Ten170*coupl(nGC_19)**2d0*(Nc**2d0  &
                 - 1d0)/Nc + Ten174*coupl(nGC_19)**2d0*(Nc**2d0 - 1d0)/Nc + 2d0&
                *Ten179*coupl(nGC_19)**2d0*rMC*(-2d0*Nc**2d0*cMC + Nc**2d0*rMC &
                 + 2d0*cMC - rMC)/Nc + 2d0*Ten183*coupl(nGC_19)**2d0*rMC**2d0*(&
                Nc**2d0 - 1d0)/Nc)/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZcR_QCD2 = cone*real(dZcR_QCD2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter34
end module ctparameter34
