!******************************************************************************!
!                                                                              !
!    ctparameter39.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter39.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter39
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter39()
  if (dZdL_QED2_scheme .eq. 2) then
    dZdL_QED2 = (Ten150*(coupl(nGC_131)**2d0 - 2d0*coupl(nGC_82)**2d0) - Ten151&
                *coupl(nGC_132)**2d0 + Ten168*(coupl(nGC_148)**2d0 + 2d0*coupl(&
                nGC_62)**2d0) + Ten169*(coupl(nGC_148)**2d0 + 2d0*coupl(nGC_62 &
                )**2d0) + Ten90*coupl(nGC_1)**2d0 + pi**2d0*(-coupl(nGC_62)**  &
                2d0/pi**2d0 - coupl(nGC_82)**2d0/pi**2d0))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZdL_QED2 = cone*real(dZdL_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter39
end module ctparameter39
