!******************************************************************************!
!                                                                              !
!    ctparameter47.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter47.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter47
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter47()
  dMH2_QED2 = (4d0*Nc*Ten18*cMU**2d0*coupl(nGC_149)**2d0 + 4d0*Nc*Ten19*cMC**  &
              2d0*coupl(nGC_128)**2d0 + 4d0*Nc*Ten20*cMT**2d0*coupl(nGC_143)** &
              2d0 + 4d0*Nc*Ten21*cMD**2d0*coupl(nGC_132)**2d0 + 4d0*Nc*Ten22*  &
              cMS**2d0*coupl(nGC_141)**2d0 + 4d0*Nc*Ten23*cMB**2d0*coupl(      &
              nGC_126)**2d0 + 4d0*Nc*Ten33*cMH**2d0*coupl(nGC_149)**2d0 + 16d0*&
              Nc*Ten34*coupl(nGC_149)**2d0 + 4d0*Nc*Ten35*cMH**2d0*coupl(      &
              nGC_149)**2d0 + 4d0*Nc*Ten36*cMH**2d0*coupl(nGC_128)**2d0 + 16d0*&
              Nc*Ten37*coupl(nGC_128)**2d0 + 4d0*Nc*Ten38*cMH**2d0*coupl(      &
              nGC_128)**2d0 + 4d0*Nc*Ten39*cMH**2d0*coupl(nGC_143)**2d0 + 16d0*&
              Nc*Ten40*coupl(nGC_143)**2d0 + 4d0*Nc*Ten41*cMH**2d0*coupl(      &
              nGC_143)**2d0 + 4d0*Nc*Ten42*cMH**2d0*coupl(nGC_132)**2d0 + 16d0*&
              Nc*Ten43*coupl(nGC_132)**2d0 + 4d0*Nc*Ten44*cMH**2d0*coupl(      &
              nGC_132)**2d0 + 4d0*Nc*Ten45*cMH**2d0*coupl(nGC_141)**2d0 + 16d0*&
              Nc*Ten46*coupl(nGC_141)**2d0 + 4d0*Nc*Ten47*cMH**2d0*coupl(      &
              nGC_141)**2d0 + 4d0*Nc*Ten48*cMH**2d0*coupl(nGC_126)**2d0 + 16d0*&
              Nc*Ten49*coupl(nGC_126)**2d0 + 4d0*Nc*Ten50*cMH**2d0*coupl(      &
              nGC_126)**2d0 + 4d0*Nc*Ten56*cMU**2d0*coupl(nGC_149)**2d0*(cMH** &
              2d0 - rMH**2d0) + 4d0*Nc*Ten57*cMC**2d0*coupl(nGC_128)**2d0*(cMH &
              **2d0 - rMH**2d0) + 4d0*Nc*Ten58*cMT**2d0*coupl(nGC_143)**2d0*(  &
              cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten59*cMD**2d0*coupl(nGC_132)**2d0 &
              *(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten60*cMS**2d0*coupl(nGC_141)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten61*cMB**2d0*coupl(nGC_126  &
              )**2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten72*coupl(nGC_149)**2d0* &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten73*coupl(nGC_149)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten74*coupl(nGC_149)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten75*coupl(nGC_128)**2d0*  &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten76*coupl(nGC_128)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten77*coupl(nGC_128)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten78*coupl(nGC_143)**2d0*  &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten79*coupl(nGC_143)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten80*coupl(nGC_143)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten81*coupl(nGC_132)**2d0*  &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten82*coupl(nGC_132)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten83*coupl(nGC_132)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten84*coupl(nGC_141)**2d0*  &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten85*coupl(nGC_141)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten86*coupl(nGC_141)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten87*coupl(nGC_126)**2d0*  &
              rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Nc*Ten88*coupl(nGC_126)**  &
              2d0*(cMH**2d0 - rMH**2d0) + 4d0*Nc*Ten89*coupl(nGC_126)**2d0*rMH &
              **2d0*(cMH**2d0 - rMH**2d0) + cima*Ten0*coupl(nGC_24)/2d0 + cima*&
              Ten1*(coupl(nGC_29) - 2d0*coupl(nGC_93) - 4d0*coupl(nGC_96))/2d0 &
               + Ten12*(-4d0*cMH**2d0*coupl(nGC_81)**2d0 - coupl(nGC_116)**2d0/&
              2d0 + coupl(nGC_122)**2d0 - 2d0*coupl(nGC_123)**2d0) + Ten13*(-  &
              8d0*cMH**2d0*coupl(nGC_59)*coupl(nGC_60) + 2d0*coupl(nGC_106)**  &
              2d0 - 4d0*coupl(nGC_107)**2d0 - coupl(nGC_115)**2d0) - Ten14*    &
              coupl(nGC_102)**2d0/2d0 + 4d0*Ten15*cME**2d0*coupl(nGC_135)**2d0 &
               + 4d0*Ten16*cMM**2d0*coupl(nGC_138)**2d0 + 4d0*Ten17*cMTA**2d0* &
              coupl(nGC_147)**2d0 + cima*Ten2*(coupl(nGC_28) - 2d0*coupl(nGC_46&
              ) - 4d0*coupl(nGC_47)) + 4d0*Ten24*cMH**2d0*coupl(nGC_135)**2d0  &
               + 16d0*Ten25*coupl(nGC_135)**2d0 + 4d0*Ten26*cMH**2d0*coupl(    &
              nGC_135)**2d0 + 4d0*Ten27*cMH**2d0*coupl(nGC_138)**2d0 + 16d0*   &
              Ten28*coupl(nGC_138)**2d0 + 4d0*Ten29*cMH**2d0*coupl(nGC_138)**  &
              2d0 + 4d0*Ten30*cMH**2d0*coupl(nGC_147)**2d0 + 16d0*Ten31*coupl( &
              nGC_147)**2d0 + 4d0*Ten32*cMH**2d0*coupl(nGC_147)**2d0 + Ten51*(-&
              cMH**2d0*coupl(nGC_116)**2d0/2d0 + cMH**2d0*coupl(nGC_122)**2d0  &
               - 2d0*cMH**2d0*coupl(nGC_123)**2d0 - 4d0*cMH**2d0*coupl(nGC_81  &
              )**2d0*rMH**2d0 + coupl(nGC_116)**2d0*rMH**2d0/2d0 - coupl(      &
              nGC_122)**2d0*rMH**2d0 + 2d0*coupl(nGC_123)**2d0*rMH**2d0 + 4d0* &
              coupl(nGC_81)**2d0*rMH**4d0) + Ten52*(2d0*cMH**2d0*coupl(nGC_106 &
              )**2d0 - 4d0*cMH**2d0*coupl(nGC_107)**2d0 - cMH**2d0*coupl(      &
              nGC_115)**2d0 - 8d0*cMH**2d0*coupl(nGC_59)*coupl(nGC_60)*rMH**2d0&
               - 2d0*coupl(nGC_106)**2d0*rMH**2d0 + 4d0*coupl(nGC_107)**2d0*rMH&
              **2d0 + coupl(nGC_115)**2d0*rMH**2d0 + 8d0*coupl(nGC_59)*coupl(  &
              nGC_60)*rMH**4d0) + 4d0*Ten53*cME**2d0*coupl(nGC_135)**2d0*(cMH**&
              2d0 - rMH**2d0) + 4d0*Ten54*cMM**2d0*coupl(nGC_138)**2d0*(cMH**  &
              2d0 - rMH**2d0) + 4d0*Ten55*cMTA**2d0*coupl(nGC_147)**2d0*(cMH** &
              2d0 - rMH**2d0) + Ten62*coupl(nGC_102)**2d0*(-cMH**2d0 + rMH**2d0&
              )/2d0 + 4d0*Ten63*coupl(nGC_135)**2d0*rMH**2d0*(cMH**2d0 - rMH** &
              2d0) + 16d0*Ten64*coupl(nGC_135)**2d0*(cMH**2d0 - rMH**2d0) + 4d0&
              *Ten65*coupl(nGC_135)**2d0*rMH**2d0*(cMH**2d0 - rMH**2d0) + 4d0* &
              Ten66*coupl(nGC_138)**2d0*rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0* &
              Ten67*coupl(nGC_138)**2d0*(cMH**2d0 - rMH**2d0) + 4d0*Ten68*coupl&
              (nGC_138)**2d0*rMH**2d0*(cMH**2d0 - rMH**2d0) + 4d0*Ten69*coupl( &
              nGC_147)**2d0*rMH**2d0*(cMH**2d0 - rMH**2d0) + 16d0*Ten70*coupl( &
              nGC_147)**2d0*(cMH**2d0 - rMH**2d0) + 4d0*Ten71*coupl(nGC_147)** &
              2d0*rMH**2d0*(cMH**2d0 - rMH**2d0) + pi**2d0*(-4d0*Nc*cMB**2d0*  &
              coupl(nGC_126)**2d0/pi**2d0 - 4d0*Nc*cMC**2d0*coupl(nGC_128)**2d0&
              /pi**2d0 - 4d0*Nc*cMD**2d0*coupl(nGC_132)**2d0/pi**2d0 + 2d0*Nc* &
              cMH**2d0*coupl(nGC_126)**2d0/(3d0*pi**2d0) + 2d0*Nc*cMH**2d0*    &
              coupl(nGC_128)**2d0/(3d0*pi**2d0) + 2d0*Nc*cMH**2d0*coupl(nGC_132&
              )**2d0/(3d0*pi**2d0) + 2d0*Nc*cMH**2d0*coupl(nGC_141)**2d0/(3d0* &
              pi**2d0) + 2d0*Nc*cMH**2d0*coupl(nGC_143)**2d0/(3d0*pi**2d0) +   &
              2d0*Nc*cMH**2d0*coupl(nGC_149)**2d0/(3d0*pi**2d0) - 4d0*Nc*cMS** &
              2d0*coupl(nGC_141)**2d0/pi**2d0 - 4d0*Nc*cMT**2d0*coupl(nGC_143  &
              )**2d0/pi**2d0 - 4d0*Nc*cMU**2d0*coupl(nGC_149)**2d0/pi**2d0 -   &
              4d0*cME**2d0*coupl(nGC_135)**2d0/pi**2d0 + 2d0*cMH**2d0*coupl(   &
              nGC_135)**2d0/(3d0*pi**2d0) + 2d0*cMH**2d0*coupl(nGC_138)**2d0/( &
              3d0*pi**2d0) + 2d0*cMH**2d0*coupl(nGC_147)**2d0/(3d0*pi**2d0) -  &
              4d0*cMM**2d0*coupl(nGC_138)**2d0/pi**2d0 - 4d0*cMTA**2d0*coupl(  &
              nGC_147)**2d0/pi**2d0 + 2d0*cima*cMW**2d0*coupl(nGC_47)/pi**2d0  &
               + cima*cMZ**2d0*coupl(nGC_96)/pi**2d0 + 2d0*coupl(nGC_107)**2d0/&
              pi**2d0 + coupl(nGC_123)**2d0/pi**2d0))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMH2_QED2 = cone*real(dMH2_QED2,kind=dp)
    end if 
end subroutine set_ctparameter47
end module ctparameter47
