!******************************************************************************!
!                                                                              !
!    ctparameter53.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter53.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter53
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter53()
  if (dZcL_QED2_scheme .eq. 0) then
    dZcL_QED2 = (2d0*Ten170*coupl(nGC_2)**2d0 + Ten171*(-coupl(nGC_129)**2d0 + &
                2d0*coupl(nGC_83)**2d0) + Ten172*(coupl(nGC_139)**2d0 + 2d0*   &
                coupl(nGC_62)**2d0) - Ten173*coupl(nGC_128)**2d0 + 2d0*Ten174* &
                coupl(nGC_2)**2d0 + Ten175*(-coupl(nGC_129)**2d0 + 2d0*coupl(  &
                nGC_83)**2d0) + Ten176*(coupl(nGC_139)**2d0 + 2d0*coupl(nGC_62 &
                )**2d0) + 2d0*Ten178*cMC*coupl(nGC_128)**2d0*rMC + 4d0*Ten179* &
                coupl(nGC_2)**2d0*rMC*(-2d0*cMC + rMC) + 2d0*Ten180*rMC*(cMC*  &
                coupl(nGC_129)**2d0 - 4d0*cMC*coupl(nGC_79)*coupl(nGC_83) -    &
                coupl(nGC_129)**2d0*rMC + coupl(nGC_79)**2d0*rMC + coupl(nGC_83&
                )**2d0*rMC) + Ten181*rMC*(2d0*cMS*coupl(nGC_127)*coupl(nGC_139 &
                ) + coupl(nGC_127)**2d0*rMC + coupl(nGC_139)**2d0*rMC + 2d0*   &
                coupl(nGC_62)**2d0*rMC) - 2d0*Ten182*coupl(nGC_128)**2d0*rMC** &
                2d0 + 4d0*Ten183*coupl(nGC_2)**2d0*rMC**2d0 + 2d0*Ten184*rMC** &
                2d0*(-coupl(nGC_129)**2d0 + coupl(nGC_79)**2d0 + coupl(nGC_83  &
                )**2d0) + Ten185*rMC**2d0*(coupl(nGC_127)**2d0 + coupl(nGC_139 &
                )**2d0 + 2d0*coupl(nGC_62)**2d0) + pi**2d0*(-coupl(nGC_2)**2d0/&
                pi**2d0 - coupl(nGC_62)**2d0/pi**2d0 - coupl(nGC_83)**2d0/pi** &
                2d0))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZcL_QED2 = cone*real(dZcL_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter53
end module ctparameter53
