!******************************************************************************!
!                                                                              !
!    ctparameter66.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter66.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter66
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter66()
  if (dMTA_QED2_scheme .eq. 0) then
    dMTA_QED2 = (2d0*Ten318*cMTA*coupl(nGC_4)**2d0 + Ten319*cMTA*(-coupl(nGC_80&
                )**2d0 + 4d0*coupl(nGC_80)*coupl(nGC_85) - coupl(nGC_85)**2d0  &
                ) + Ten320*cMTA*coupl(nGC_147)**2d0 - 2d0*Ten321*cMTA*coupl(   &
                nGC_4)**2d0 + Ten322*cMTA*(coupl(nGC_145)**2d0 + 2d0*coupl(    &
                nGC_62)**2d0)/2d0 + Ten323*cMTA*(coupl(nGC_146)**2d0 - coupl(  &
                nGC_80)**2d0 - coupl(nGC_85)**2d0) - Ten324*cMTA*coupl(nGC_147 &
                )**2d0 + 2d0*Ten325*cMTA*coupl(nGC_147)**2d0*rMTA*(-cMTA + rMTA&
                ) + 4d0*Ten326*coupl(nGC_4)**2d0*rMTA*(2d0*cMTA**2d0 - 3d0*cMTA&
                *rMTA + rMTA**2d0) + 2d0*Ten327*rMTA*(-cMTA**2d0*coupl(nGC_146 &
                )**2d0 + 4d0*cMTA**2d0*coupl(nGC_80)*coupl(nGC_85) + 2d0*cMTA* &
                coupl(nGC_146)**2d0*rMTA - cMTA*coupl(nGC_80)**2d0*rMTA - 4d0* &
                cMTA*coupl(nGC_80)*coupl(nGC_85)*rMTA - cMTA*coupl(nGC_85)**2d0&
                *rMTA - coupl(nGC_146)**2d0*rMTA**2d0 + coupl(nGC_80)**2d0*rMTA&
                **2d0 + coupl(nGC_85)**2d0*rMTA**2d0) + 2d0*Ten328*coupl(      &
                nGC_147)**2d0*rMTA**2d0*(cMTA - rMTA) + 4d0*Ten329*coupl(nGC_4 &
                )**2d0*rMTA**2d0*(-cMTA + rMTA) + Ten330*rMTA**2d0*(cMTA*coupl(&
                nGC_145)**2d0 + 2d0*cMTA*coupl(nGC_62)**2d0 - coupl(nGC_145)** &
                2d0*rMTA - 2d0*coupl(nGC_62)**2d0*rMTA) + 2d0*Ten331*rMTA**2d0 &
                *(cMTA*coupl(nGC_146)**2d0 - cMTA*coupl(nGC_80)**2d0 - cMTA*   &
                coupl(nGC_85)**2d0 - coupl(nGC_146)**2d0*rMTA + coupl(nGC_80)**&
                2d0*rMTA + coupl(nGC_85)**2d0*rMTA) + pi**2d0*(-8d0*aEW*cMTA** &
                2d0/(pi*rMTA) + 8d0*aEW*rMTA/pi - cMTA*coupl(nGC_4)**2d0/pi**  &
                2d0 + cMTA*coupl(nGC_62)**2d0/(2d0*pi**2d0) + cMTA*coupl(nGC_80&
                )**2d0/(2d0*pi**2d0) - 2d0*cMTA*coupl(nGC_80)*coupl(nGC_85)/pi &
                **2d0 + cMTA*coupl(nGC_85)**2d0/(2d0*pi**2d0)))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMTA_QED2 = cone*real(dMTA_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter66
end module ctparameter66
