!******************************************************************************!
!                                                                              !
!    ctparameter70.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter70.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter70
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter70()
  dZZA_QED2 = (4d0*Nc*Ten103*cMU**2d0*coupl(nGC_2)*(-coupl(nGC_79) - coupl(    &
              nGC_83))/cMZ**2d0 + 4d0*Nc*Ten104*cMC**2d0*coupl(nGC_2)*(-coupl( &
              nGC_79) - coupl(nGC_83))/cMZ**2d0 + 4d0*Nc*Ten105*cMT**2d0*coupl(&
              nGC_2)*(-coupl(nGC_79) - coupl(nGC_83))/cMZ**2d0 + 4d0*Nc*Ten106*&
              cMD**2d0*coupl(nGC_1)*(-coupl(nGC_78) - coupl(nGC_82))/cMZ**2d0  &
               + 4d0*Nc*Ten107*cMS**2d0*coupl(nGC_1)*(-coupl(nGC_78) - coupl(  &
              nGC_82))/cMZ**2d0 + 4d0*Nc*Ten108*cMB**2d0*coupl(nGC_1)*(-coupl( &
              nGC_78) - coupl(nGC_82))/cMZ**2d0 + 8d0*Nc*Ten109*coupl(nGC_2)*( &
              coupl(nGC_79) + coupl(nGC_83))/cMZ**2d0 + 8d0*Nc*Ten110*coupl(   &
              nGC_2)*(coupl(nGC_79) + coupl(nGC_83))/cMZ**2d0 + 8d0*Nc*Ten111* &
              coupl(nGC_2)*(coupl(nGC_79) + coupl(nGC_83))/cMZ**2d0 + 8d0*Nc*  &
              Ten112*coupl(nGC_1)*(coupl(nGC_78) + coupl(nGC_82))/cMZ**2d0 +   &
              8d0*Nc*Ten113*coupl(nGC_1)*(coupl(nGC_78) + coupl(nGC_82))/cMZ** &
              2d0 + 8d0*Nc*Ten114*coupl(nGC_1)*(coupl(nGC_78) + coupl(nGC_82))/&
              cMZ**2d0 + 2d0*cima*Ten2*(2d0*coupl(nGC_76) + 4d0*coupl(nGC_77   &
              ) - coupl(nGC_90))/cMZ**2d0 + 2d0*Ten353*(16d0*coupl(nGC_3)*coupl&
              (nGC_64) + 4d0*coupl(nGC_4)*coupl(nGC_85) - coupl(nGC_5)*coupl(  &
              nGC_66) - coupl(nGC_6)*coupl(nGC_65))/cMZ**2d0 + 4d0*Ten360*cME**&
              2d0*coupl(nGC_4)*(-coupl(nGC_80) - coupl(nGC_85))/cMZ**2d0 + 4d0*&
              Ten361*cMM**2d0*coupl(nGC_4)*(-coupl(nGC_80) - coupl(nGC_85))/cMZ&
              **2d0 + 4d0*Ten362*cMTA**2d0*coupl(nGC_4)*(-coupl(nGC_80) - coupl&
              (nGC_85))/cMZ**2d0 + 8d0*Ten363*coupl(nGC_4)*(coupl(nGC_80) +    &
              coupl(nGC_85))/cMZ**2d0 + 8d0*Ten364*coupl(nGC_4)*(coupl(nGC_80  &
              ) + coupl(nGC_85))/cMZ**2d0 + 8d0*Ten365*coupl(nGC_4)*(coupl(    &
              nGC_80) + coupl(nGC_85))/cMZ**2d0 + pi**2d0*(-4d0*Nc*cMB**2d0*   &
              coupl(nGC_1)*coupl(nGC_78)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMB**2d0* &
              coupl(nGC_1)*coupl(nGC_82)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMC**2d0* &
              coupl(nGC_2)*coupl(nGC_79)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMC**2d0* &
              coupl(nGC_2)*coupl(nGC_83)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMD**2d0* &
              coupl(nGC_1)*coupl(nGC_78)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMD**2d0* &
              coupl(nGC_1)*coupl(nGC_82)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMS**2d0* &
              coupl(nGC_1)*coupl(nGC_78)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMS**2d0* &
              coupl(nGC_1)*coupl(nGC_82)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMT**2d0* &
              coupl(nGC_2)*coupl(nGC_79)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMT**2d0* &
              coupl(nGC_2)*coupl(nGC_83)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMU**2d0* &
              coupl(nGC_2)*coupl(nGC_79)/(pi**2d0*cMZ**2d0) - 4d0*Nc*cMU**2d0* &
              coupl(nGC_2)*coupl(nGC_83)/(pi**2d0*cMZ**2d0) - 4d0*cME**2d0*    &
              coupl(nGC_4)*coupl(nGC_80)/(pi**2d0*cMZ**2d0) - 4d0*cME**2d0*    &
              coupl(nGC_4)*coupl(nGC_85)/(pi**2d0*cMZ**2d0) - 4d0*cMM**2d0*    &
              coupl(nGC_4)*coupl(nGC_80)/(pi**2d0*cMZ**2d0) - 4d0*cMM**2d0*    &
              coupl(nGC_4)*coupl(nGC_85)/(pi**2d0*cMZ**2d0) - 4d0*cMTA**2d0*   &
              coupl(nGC_4)*coupl(nGC_80)/(pi**2d0*cMZ**2d0) - 4d0*cMTA**2d0*   &
              coupl(nGC_4)*coupl(nGC_85)/(pi**2d0*cMZ**2d0) - 8d0*cMW**2d0*    &
              coupl(nGC_3)*coupl(nGC_64)/(pi**2d0*cMZ**2d0) - 4d0*cima*cMW**2d0&
              *coupl(nGC_77)/(pi**2d0*cMZ**2d0)))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZZA_QED2 = cone*real(dZZA_QED2,kind=dp)
    end if 
end subroutine set_ctparameter70
end module ctparameter70
