!******************************************************************************!
!                                                                              !
!    ctparameter80.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter80.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter80
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter80()
  if (dME_QED2_scheme .eq. 0) then
    dME_QED2 = (2d0*Ten275*cME*coupl(nGC_4)**2d0 + Ten276*cME*(-coupl(nGC_80)**&
               2d0 + 4d0*coupl(nGC_80)*coupl(nGC_85) - coupl(nGC_85)**2d0) +   &
               Ten277*cME*coupl(nGC_135)**2d0 - 2d0*Ten278*cME*coupl(nGC_4)**  &
               2d0 + Ten279*cME*(coupl(nGC_133)**2d0 + 2d0*coupl(nGC_62)**2d0)/&
               2d0 + Ten280*cME*(coupl(nGC_134)**2d0 - coupl(nGC_80)**2d0 -    &
               coupl(nGC_85)**2d0) - Ten281*cME*coupl(nGC_135)**2d0 + pi**2d0  &
               *(-cME*coupl(nGC_4)**2d0/pi**2d0 + cME*coupl(nGC_62)**2d0/(2d0* &
               pi**2d0) + cME*coupl(nGC_80)**2d0/(2d0*pi**2d0) - 2d0*cME*coupl(&
               nGC_80)*coupl(nGC_85)/pi**2d0 + cME*coupl(nGC_85)**2d0/(2d0*pi**&
               2d0)))/(16d0*pi**2d0)
    dME_QED2 = cone*real(dME_QED2,kind=dp)
  end if 
end subroutine set_ctparameter80
end module ctparameter80
