!******************************************************************************!
!                                                                              !
!    ctparameter88.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter88.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter88
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter88()
  if (dZmuMinusR_QED2_scheme .eq. 0) then
    dZmuMinusR_QED2 = (2d0*Ten290*coupl(nGC_4)**2d0 + Ten291*(-coupl(nGC_137)**&
                      2d0 + 2d0*coupl(nGC_80)**2d0) - Ten292*coupl(nGC_138)**  &
                      2d0 + 2d0*Ten293*coupl(nGC_4)**2d0 - Ten294*coupl(nGC_136&
                      )**2d0 + Ten295*(-coupl(nGC_137)**2d0 + 2d0*coupl(nGC_80 &
                      )**2d0) + 2d0*Ten297*cMM*coupl(nGC_138)**2d0*rMM + 4d0*  &
                      Ten298*coupl(nGC_4)**2d0*rMM*(-2d0*cMM + rMM) + 2d0*     &
                      Ten299*rMM*(cMM*coupl(nGC_137)**2d0 - 4d0*cMM*coupl(     &
                      nGC_80)*coupl(nGC_85) - coupl(nGC_137)**2d0*rMM + coupl( &
                      nGC_80)**2d0*rMM + coupl(nGC_85)**2d0*rMM) - 2d0*Ten300* &
                      coupl(nGC_138)**2d0*rMM**2d0 + 4d0*Ten301*coupl(nGC_4)** &
                      2d0*rMM**2d0 + Ten302*rMM**2d0*(-coupl(nGC_136)**2d0 -   &
                      2d0*coupl(nGC_62)**2d0) + 2d0*Ten303*rMM**2d0*(-coupl(   &
                      nGC_137)**2d0 + coupl(nGC_80)**2d0 + coupl(nGC_85)**2d0  &
                      ) + pi**2d0*(-coupl(nGC_4)**2d0/pi**2d0 - coupl(nGC_80)**&
                      2d0/pi**2d0))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dZmuMinusR_QED2 = cone*real(dZmuMinusR_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter88
end module ctparameter88
