!******************************************************************************!
!                                                                              !
!    ctparameter94.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter94.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter94
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter94()
  dMZ2_QED2 = (2d0*Nc*Ten383*(-6d0*cMU**2d0*coupl(nGC_79)*coupl(nGC_83) - cMZ**&
              2d0*coupl(nGC_79)**2d0 - cMZ**2d0*coupl(nGC_83)**2d0 + coupl(    &
              nGC_79)**2d0*rMZ**2d0 + coupl(nGC_83)**2d0*rMZ**2d0)/3d0 + 2d0*Nc&
              *Ten384*(-6d0*cMC**2d0*coupl(nGC_79)*coupl(nGC_83) - cMZ**2d0*   &
              coupl(nGC_79)**2d0 - cMZ**2d0*coupl(nGC_83)**2d0 + coupl(nGC_79  &
              )**2d0*rMZ**2d0 + coupl(nGC_83)**2d0*rMZ**2d0)/3d0 + 2d0*Nc*     &
              Ten385*(-6d0*cMT**2d0*coupl(nGC_79)*coupl(nGC_83) - cMZ**2d0*    &
              coupl(nGC_79)**2d0 - cMZ**2d0*coupl(nGC_83)**2d0 + coupl(nGC_79  &
              )**2d0*rMZ**2d0 + coupl(nGC_83)**2d0*rMZ**2d0)/3d0 + 2d0*Nc*     &
              Ten386*(-6d0*cMD**2d0*coupl(nGC_78)*coupl(nGC_82) - cMZ**2d0*    &
              coupl(nGC_78)**2d0 - cMZ**2d0*coupl(nGC_82)**2d0 + coupl(nGC_78  &
              )**2d0*rMZ**2d0 + coupl(nGC_82)**2d0*rMZ**2d0)/3d0 + 2d0*Nc*     &
              Ten387*(-6d0*cMS**2d0*coupl(nGC_78)*coupl(nGC_82) - cMZ**2d0*    &
              coupl(nGC_78)**2d0 - cMZ**2d0*coupl(nGC_82)**2d0 + coupl(nGC_78  &
              )**2d0*rMZ**2d0 + coupl(nGC_82)**2d0*rMZ**2d0)/3d0 + 2d0*Nc*     &
              Ten388*(-6d0*cMB**2d0*coupl(nGC_78)*coupl(nGC_82) - cMZ**2d0*    &
              coupl(nGC_78)**2d0 - cMZ**2d0*coupl(nGC_82)**2d0 + coupl(nGC_78  &
              )**2d0*rMZ**2d0 + coupl(nGC_82)**2d0*rMZ**2d0)/3d0 + 4d0*Nc*     &
              Ten399*(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 4d0*Nc*Ten400 &
              *(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 4d0*Nc*Ten401*(coupl&
              (nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*Ten402*rMZ**2d0*(   &
              coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*Ten403*rMZ**2d0&
              *(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*Ten404*rMZ** &
              2d0*(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*Ten405*rMZ&
              **2d0*(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*Ten406* &
              rMZ**2d0*(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 2d0*Nc*     &
              Ten407*rMZ**2d0*(coupl(nGC_79)**2d0 + coupl(nGC_83)**2d0) + 4d0* &
              Nc*Ten408*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 4d0*Nc*    &
              Ten409*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 4d0*Nc*Ten410 &
              *(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 2d0*Nc*Ten411*rMZ** &
              2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 2d0*Nc*Ten412*rMZ&
              **2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 2d0*Nc*Ten413* &
              rMZ**2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 2d0*Nc*     &
              Ten414*rMZ**2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) + 2d0* &
              Nc*Ten415*rMZ**2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0) +   &
              2d0*Nc*Ten416*rMZ**2d0*(coupl(nGC_78)**2d0 + coupl(nGC_82)**2d0  &
              ) + 2d0*Nc*Ten426*(cMU**2d0*cMZ**2d0*coupl(nGC_79)**2d0 - 6d0*cMU&
              **2d0*cMZ**2d0*coupl(nGC_79)*coupl(nGC_83) + cMU**2d0*cMZ**2d0*  &
              coupl(nGC_83)**2d0 - cMU**2d0*coupl(nGC_79)**2d0*rMZ**2d0 + 6d0* &
              cMU**2d0*coupl(nGC_79)*coupl(nGC_83)*rMZ**2d0 - cMU**2d0*coupl(  &
              nGC_83)**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_79)**2d0*rMZ**2d0 -   &
              cMZ**2d0*coupl(nGC_83)**2d0*rMZ**2d0 + coupl(nGC_79)**2d0*rMZ**  &
              4d0 + coupl(nGC_83)**2d0*rMZ**4d0)/3d0 + 2d0*Nc*Ten427*(cMC**2d0*&
              cMZ**2d0*coupl(nGC_79)**2d0 - 6d0*cMC**2d0*cMZ**2d0*coupl(nGC_79 &
              )*coupl(nGC_83) + cMC**2d0*cMZ**2d0*coupl(nGC_83)**2d0 - cMC**2d0&
              *coupl(nGC_79)**2d0*rMZ**2d0 + 6d0*cMC**2d0*coupl(nGC_79)*coupl( &
              nGC_83)*rMZ**2d0 - cMC**2d0*coupl(nGC_83)**2d0*rMZ**2d0 - cMZ**  &
              2d0*coupl(nGC_79)**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_83)**2d0*rMZ&
              **2d0 + coupl(nGC_79)**2d0*rMZ**4d0 + coupl(nGC_83)**2d0*rMZ**4d0&
              )/3d0 + 2d0*Nc*Ten428*(cMT**2d0*cMZ**2d0*coupl(nGC_79)**2d0 - 6d0&
              *cMT**2d0*cMZ**2d0*coupl(nGC_79)*coupl(nGC_83) + cMT**2d0*cMZ**  &
              2d0*coupl(nGC_83)**2d0 - cMT**2d0*coupl(nGC_79)**2d0*rMZ**2d0 +  &
              6d0*cMT**2d0*coupl(nGC_79)*coupl(nGC_83)*rMZ**2d0 - cMT**2d0*    &
              coupl(nGC_83)**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_79)**2d0*rMZ**  &
              2d0 - cMZ**2d0*coupl(nGC_83)**2d0*rMZ**2d0 + coupl(nGC_79)**2d0* &
              rMZ**4d0 + coupl(nGC_83)**2d0*rMZ**4d0)/3d0 + 2d0*Nc*Ten429*(cMD &
              **2d0*cMZ**2d0*coupl(nGC_78)**2d0 - 6d0*cMD**2d0*cMZ**2d0*coupl( &
              nGC_78)*coupl(nGC_82) + cMD**2d0*cMZ**2d0*coupl(nGC_82)**2d0 -   &
              cMD**2d0*coupl(nGC_78)**2d0*rMZ**2d0 + 6d0*cMD**2d0*coupl(nGC_78 &
              )*coupl(nGC_82)*rMZ**2d0 - cMD**2d0*coupl(nGC_82)**2d0*rMZ**2d0  &
               - cMZ**2d0*coupl(nGC_78)**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_82  &
              )**2d0*rMZ**2d0 + coupl(nGC_78)**2d0*rMZ**4d0 + coupl(nGC_82)**  &
              2d0*rMZ**4d0)/3d0 + 2d0*Nc*Ten430*(cMS**2d0*cMZ**2d0*coupl(nGC_78&
              )**2d0 - 6d0*cMS**2d0*cMZ**2d0*coupl(nGC_78)*coupl(nGC_82) + cMS &
              **2d0*cMZ**2d0*coupl(nGC_82)**2d0 - cMS**2d0*coupl(nGC_78)**2d0* &
              rMZ**2d0 + 6d0*cMS**2d0*coupl(nGC_78)*coupl(nGC_82)*rMZ**2d0 -   &
              cMS**2d0*coupl(nGC_82)**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_78)**  &
              2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_82)**2d0*rMZ**2d0 + coupl(     &
              nGC_78)**2d0*rMZ**4d0 + coupl(nGC_82)**2d0*rMZ**4d0)/3d0 + 2d0*Nc&
              *Ten431*(cMB**2d0*cMZ**2d0*coupl(nGC_78)**2d0 - 6d0*cMB**2d0*cMZ &
              **2d0*coupl(nGC_78)*coupl(nGC_82) + cMB**2d0*cMZ**2d0*coupl(     &
              nGC_82)**2d0 - cMB**2d0*coupl(nGC_78)**2d0*rMZ**2d0 + 6d0*cMB**  &
              2d0*coupl(nGC_78)*coupl(nGC_82)*rMZ**2d0 - cMB**2d0*coupl(nGC_82 &
              )**2d0*rMZ**2d0 - cMZ**2d0*coupl(nGC_78)**2d0*rMZ**2d0 - cMZ**2d0&
              *coupl(nGC_82)**2d0*rMZ**2d0 + coupl(nGC_78)**2d0*rMZ**4d0 +     &
              coupl(nGC_82)**2d0*rMZ**4d0)/3d0 + Ten0*(2d0*cMH**2d0*cMZ**2d0*  &
              coupl(nGC_81)**2d0 - 2d0*cMH**2d0*coupl(nGC_81)**2d0*rMZ**2d0 -  &
              2d0*cMZ**4d0*coupl(nGC_81)**2d0 + 2d0*cMZ**2d0*coupl(nGC_81)**2d0&
              *rMZ**2d0 - 3d0*cima*coupl(nGC_96)*rMZ**4d0)/(6d0*rMZ**4d0) +    &
              Ten1*(-2d0*cMH**2d0*cMZ**2d0*coupl(nGC_81)**2d0 + 2d0*cMH**2d0*  &
              coupl(nGC_81)**2d0*rMZ**2d0 + 2d0*cMZ**4d0*coupl(nGC_81)**2d0 -  &
              2d0*cMZ**2d0*coupl(nGC_81)**2d0*rMZ**2d0 - 3d0*cima*coupl(nGC_96 &
              )*rMZ**4d0)/(6d0*rMZ**4d0) + cima*Ten2*(4d0*coupl(nGC_56) + 2d0* &
              coupl(nGC_57) - coupl(nGC_95)) + Ten378*(-cMH**4d0*cMZ**2d0*coupl&
              (nGC_81)**2d0 + cMH**4d0*coupl(nGC_81)**2d0*rMZ**2d0 + 2d0*cMH** &
              2d0*cMZ**4d0*coupl(nGC_81)**2d0 - 2d0*cMH**2d0*cMZ**2d0*coupl(   &
              nGC_81)**2d0*rMZ**2d0 - cMZ**6d0*coupl(nGC_81)**2d0 + cMZ**4d0*  &
              coupl(nGC_81)**2d0*rMZ**2d0 + cMZ**2d0*coupl(nGC_81)**2d0*rMZ**  &
              4d0 - 3d0*coupl(nGC_123)**2d0*rMZ**4d0 - coupl(nGC_81)**2d0*rMZ**&
              6d0)/(3d0*rMZ**4d0) + Ten379*(20d0*cMZ**2d0*coupl(nGC_64)**2d0/  &
              3d0 + cMZ**2d0*coupl(nGC_65)**2d0/12d0 + cMZ**2d0*coupl(nGC_66)**&
              2d0/12d0 - cMZ**2d0*coupl(nGC_85)**2d0/3d0 - 2d0*coupl(nGC_119)**&
              2d0 + 4d0*coupl(nGC_64)**2d0*rMZ**2d0/3d0 - coupl(nGC_65)**2d0*  &
              rMZ**2d0/12d0 - coupl(nGC_66)**2d0*rMZ**2d0/12d0 + coupl(nGC_85  &
              )**2d0*rMZ**2d0/3d0) + Ten380*(-4d0*cME**2d0*coupl(nGC_80)*coupl(&
              nGC_85) - 2d0*cMZ**2d0*coupl(nGC_80)**2d0/3d0 - 2d0*cMZ**2d0*    &
              coupl(nGC_85)**2d0/3d0 + 2d0*coupl(nGC_80)**2d0*rMZ**2d0/3d0 +   &
              2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0) + Ten381*(-4d0*cMM**2d0*    &
              coupl(nGC_80)*coupl(nGC_85) - 2d0*cMZ**2d0*coupl(nGC_80)**2d0/3d0&
               - 2d0*cMZ**2d0*coupl(nGC_85)**2d0/3d0 + 2d0*coupl(nGC_80)**2d0* &
              rMZ**2d0/3d0 + 2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0) + Ten382*(-  &
              4d0*cMTA**2d0*coupl(nGC_80)*coupl(nGC_85) - 2d0*cMZ**2d0*coupl(  &
              nGC_80)**2d0/3d0 - 2d0*cMZ**2d0*coupl(nGC_85)**2d0/3d0 + 2d0*    &
              coupl(nGC_80)**2d0*rMZ**2d0/3d0 + 2d0*coupl(nGC_85)**2d0*rMZ**2d0&
              /3d0) + Ten389*(16d0*coupl(nGC_64)**2d0 - coupl(nGC_65)**2d0 -   &
              coupl(nGC_66)**2d0 + 4d0*coupl(nGC_85)**2d0) + Ten390*(4d0*coupl(&
              nGC_80)**2d0 + 4d0*coupl(nGC_85)**2d0) + Ten391*(4d0*coupl(nGC_80&
              )**2d0 + 4d0*coupl(nGC_85)**2d0) + Ten392*(4d0*coupl(nGC_80)**2d0&
               + 4d0*coupl(nGC_85)**2d0) + 2d0*Ten393*rMZ**2d0*(coupl(nGC_80)**&
              2d0 + coupl(nGC_85)**2d0) + 2d0*Ten394*rMZ**2d0*(coupl(nGC_80)** &
              2d0 + coupl(nGC_85)**2d0) + 2d0*Ten395*rMZ**2d0*(coupl(nGC_80)** &
              2d0 + coupl(nGC_85)**2d0) + 2d0*Ten396*rMZ**2d0*(coupl(nGC_80)** &
              2d0 + coupl(nGC_85)**2d0) + 2d0*Ten397*rMZ**2d0*(coupl(nGC_80)** &
              2d0 + coupl(nGC_85)**2d0) + 2d0*Ten398*rMZ**2d0*(coupl(nGC_80)** &
              2d0 + coupl(nGC_85)**2d0) - 4d0*Ten417*coupl(nGC_81)**2d0 + 12d0*&
              Ten418*coupl(nGC_86)**2d0 + 6d0*Ten419*coupl(nGC_86)**2d0*rMZ**  &
              2d0 + 6d0*Ten420*coupl(nGC_86)**2d0*rMZ**2d0 + 2d0*Ten421*coupl( &
              nGC_86)**2d0*(-cMZ**2d0 + rMZ**2d0) + Ten422*(16d0*cMW**2d0*cMZ**&
              2d0*coupl(nGC_64)**2d0/3d0 - cMW**2d0*cMZ**2d0*coupl(nGC_65)**2d0&
              /3d0 - cMW**2d0*cMZ**2d0*coupl(nGC_66)**2d0/3d0 + 4d0*cMW**2d0*  &
              cMZ**2d0*coupl(nGC_85)**2d0/3d0 - 16d0*cMW**2d0*coupl(nGC_64)**  &
              2d0*rMZ**2d0/3d0 + cMW**2d0*coupl(nGC_65)**2d0*rMZ**2d0/3d0 + cMW&
              **2d0*coupl(nGC_66)**2d0*rMZ**2d0/3d0 - 4d0*cMW**2d0*coupl(nGC_85&
              )**2d0*rMZ**2d0/3d0 - 2d0*cMZ**2d0*coupl(nGC_119)**2d0 + 20d0*cMZ&
              **2d0*coupl(nGC_64)**2d0*rMZ**2d0/3d0 + cMZ**2d0*coupl(nGC_65)** &
              2d0*rMZ**2d0/12d0 + cMZ**2d0*coupl(nGC_66)**2d0*rMZ**2d0/12d0 -  &
              cMZ**2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0 + 2d0*coupl(nGC_119)**  &
              2d0*rMZ**2d0 - 20d0*coupl(nGC_64)**2d0*rMZ**4d0/3d0 - coupl(     &
              nGC_65)**2d0*rMZ**4d0/12d0 - coupl(nGC_66)**2d0*rMZ**4d0/12d0 +  &
              coupl(nGC_85)**2d0*rMZ**4d0/3d0) + Ten423*(2d0*cME**2d0*cMZ**2d0*&
              coupl(nGC_80)**2d0/3d0 - 4d0*cME**2d0*cMZ**2d0*coupl(nGC_80)*    &
              coupl(nGC_85) + 2d0*cME**2d0*cMZ**2d0*coupl(nGC_85)**2d0/3d0 -   &
              2d0*cME**2d0*coupl(nGC_80)**2d0*rMZ**2d0/3d0 + 4d0*cME**2d0*coupl&
              (nGC_80)*coupl(nGC_85)*rMZ**2d0 - 2d0*cME**2d0*coupl(nGC_85)**2d0&
              *rMZ**2d0/3d0 - 2d0*cMZ**2d0*coupl(nGC_80)**2d0*rMZ**2d0/3d0 -   &
              2d0*cMZ**2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0 + 2d0*coupl(nGC_80  &
              )**2d0*rMZ**4d0/3d0 + 2d0*coupl(nGC_85)**2d0*rMZ**4d0/3d0) +     &
              Ten424*(2d0*cMM**2d0*cMZ**2d0*coupl(nGC_80)**2d0/3d0 - 4d0*cMM** &
              2d0*cMZ**2d0*coupl(nGC_80)*coupl(nGC_85) + 2d0*cMM**2d0*cMZ**2d0*&
              coupl(nGC_85)**2d0/3d0 - 2d0*cMM**2d0*coupl(nGC_80)**2d0*rMZ**2d0&
              /3d0 + 4d0*cMM**2d0*coupl(nGC_80)*coupl(nGC_85)*rMZ**2d0 - 2d0*  &
              cMM**2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0 - 2d0*cMZ**2d0*coupl(   &
              nGC_80)**2d0*rMZ**2d0/3d0 - 2d0*cMZ**2d0*coupl(nGC_85)**2d0*rMZ**&
              2d0/3d0 + 2d0*coupl(nGC_80)**2d0*rMZ**4d0/3d0 + 2d0*coupl(nGC_85 &
              )**2d0*rMZ**4d0/3d0) + Ten425*(2d0*cMTA**2d0*cMZ**2d0*coupl(     &
              nGC_80)**2d0/3d0 - 4d0*cMTA**2d0*cMZ**2d0*coupl(nGC_80)*coupl(   &
              nGC_85) + 2d0*cMTA**2d0*cMZ**2d0*coupl(nGC_85)**2d0/3d0 - 2d0*   &
              cMTA**2d0*coupl(nGC_80)**2d0*rMZ**2d0/3d0 + 4d0*cMTA**2d0*coupl( &
              nGC_80)*coupl(nGC_85)*rMZ**2d0 - 2d0*cMTA**2d0*coupl(nGC_85)**2d0&
              *rMZ**2d0/3d0 - 2d0*cMZ**2d0*coupl(nGC_80)**2d0*rMZ**2d0/3d0 -   &
              2d0*cMZ**2d0*coupl(nGC_85)**2d0*rMZ**2d0/3d0 + 2d0*coupl(nGC_80  &
              )**2d0*rMZ**4d0/3d0 + 2d0*coupl(nGC_85)**2d0*rMZ**4d0/3d0) + 2d0*&
              Ten432*coupl(nGC_86)**2d0*rMZ**2d0*(-cMZ**2d0 + rMZ**2d0) +      &
              Ten433*(cMH**4d0*cMZ**2d0*coupl(nGC_81)**2d0 - cMH**4d0*coupl(   &
              nGC_81)**2d0*rMZ**2d0 - 2d0*cMH**2d0*cMZ**4d0*coupl(nGC_81)**2d0 &
               + 2d0*cMH**2d0*coupl(nGC_81)**2d0*rMZ**4d0 + cMZ**6d0*coupl(    &
              nGC_81)**2d0 - 3d0*cMZ**4d0*coupl(nGC_81)**2d0*rMZ**2d0 - 3d0*cMZ&
              **2d0*coupl(nGC_123)**2d0*rMZ**2d0 + 3d0*cMZ**2d0*coupl(nGC_81)**&
              2d0*rMZ**4d0 + 3d0*coupl(nGC_123)**2d0*rMZ**4d0 - coupl(nGC_81)**&
              2d0*rMZ**6d0)/(3d0*rMZ**2d0) + pi**2d0*(-2d0*Nc*cMB**2d0*coupl(  &
              nGC_78)**2d0/pi**2d0 - 2d0*Nc*cMB**2d0*coupl(nGC_82)**2d0/pi**2d0&
               - 2d0*Nc*cMC**2d0*coupl(nGC_79)**2d0/pi**2d0 - 2d0*Nc*cMC**2d0* &
              coupl(nGC_83)**2d0/pi**2d0 - 2d0*Nc*cMD**2d0*coupl(nGC_78)**2d0/ &
              pi**2d0 - 2d0*Nc*cMD**2d0*coupl(nGC_82)**2d0/pi**2d0 - 2d0*Nc*cMS&
              **2d0*coupl(nGC_78)**2d0/pi**2d0 - 2d0*Nc*cMS**2d0*coupl(nGC_82  &
              )**2d0/pi**2d0 - 2d0*Nc*cMT**2d0*coupl(nGC_79)**2d0/pi**2d0 - 2d0&
              *Nc*cMT**2d0*coupl(nGC_83)**2d0/pi**2d0 - 2d0*Nc*cMU**2d0*coupl( &
              nGC_79)**2d0/pi**2d0 - 2d0*Nc*cMU**2d0*coupl(nGC_83)**2d0/pi**2d0&
               + 2d0*Nc*cMZ**2d0*coupl(nGC_78)**2d0/(3d0*pi**2d0) + 2d0*Nc*cMZ &
              **2d0*coupl(nGC_79)**2d0/(3d0*pi**2d0) + 2d0*Nc*cMZ**2d0*coupl(  &
              nGC_82)**2d0/(3d0*pi**2d0) + 2d0*Nc*cMZ**2d0*coupl(nGC_83)**2d0/(&
              3d0*pi**2d0) + Nc*coupl(nGC_78)**2d0*rMZ**2d0/(3d0*pi**2d0) + Nc*&
              coupl(nGC_79)**2d0*rMZ**2d0/(3d0*pi**2d0) + Nc*coupl(nGC_82)**2d0&
              *rMZ**2d0/(3d0*pi**2d0) + Nc*coupl(nGC_83)**2d0*rMZ**2d0/(3d0*pi &
              **2d0) - 2d0*cME**2d0*coupl(nGC_80)**2d0/pi**2d0 - 2d0*cME**2d0* &
              coupl(nGC_85)**2d0/pi**2d0 - 2d0*cMM**2d0*coupl(nGC_80)**2d0/pi**&
              2d0 - 2d0*cMM**2d0*coupl(nGC_85)**2d0/pi**2d0 - 2d0*cMTA**2d0*   &
              coupl(nGC_80)**2d0/pi**2d0 - 2d0*cMTA**2d0*coupl(nGC_85)**2d0/pi &
              **2d0 - 2d0*cima*cMW**2d0*coupl(nGC_56)/pi**2d0 - 4d0*cMW**2d0*  &
              coupl(nGC_64)**2d0/pi**2d0 - 2d0*cMZ**2d0*coupl(nGC_64)**2d0/(9d0&
              *pi**2d0) + cMZ**2d0*coupl(nGC_65)**2d0/(18d0*pi**2d0) + cMZ**2d0&
              *coupl(nGC_66)**2d0/(18d0*pi**2d0) + 2d0*cMZ**2d0*coupl(nGC_80)**&
              2d0/(3d0*pi**2d0) + 2d0*cMZ**2d0*coupl(nGC_81)**2d0/(9d0*pi**2d0 &
              ) + 4d0*cMZ**2d0*coupl(nGC_85)**2d0/(9d0*pi**2d0) + 2d0*cMZ**2d0*&
              coupl(nGC_86)**2d0/(3d0*pi**2d0) + 8d0*coupl(nGC_64)**2d0*rMZ**  &
              2d0/(9d0*pi**2d0) - coupl(nGC_65)**2d0*rMZ**2d0/(18d0*pi**2d0) - &
              coupl(nGC_66)**2d0*rMZ**2d0/(18d0*pi**2d0) + coupl(nGC_80)**2d0* &
              rMZ**2d0/(3d0*pi**2d0) - 2d0*coupl(nGC_81)**2d0*rMZ**2d0/(9d0*pi &
              **2d0) + 5d0*coupl(nGC_85)**2d0*rMZ**2d0/(9d0*pi**2d0) + coupl(  &
              nGC_86)**2d0*rMZ**2d0/(3d0*pi**2d0)))/(16d0*pi**2d0)
    if (.not. complex_mass_scheme) then
      dMZ2_QED2 = cone*real(dMZ2_QED2,kind=dp)
    end if 
end subroutine set_ctparameter94
end module ctparameter94
