!******************************************************************************!
!                                                                              !
!    tcVFaF0.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVFaF0.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-10-10 22:03             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVFaF0
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeVFaF0(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last, &
    VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VFaF0)
!       GammaP(1,2,3)*c0
!       GammaM(1,2,3)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(1)*w1(0)
      x1 = pl(1)*w1(3)
      x2 = cima*w1(2)
      x3 = -pl(2)*w1(1) + pl(2)*x2
      x4 = co(1)*w2(0)
      x5 = pl(1)*w1(1)
      x6 = pl(2)*w1(3)
      x7 = -pl(2)*w1(0)
      x8 = pl(1)*x2
      x9 = co(1)*w2(1)
      x10 = w1(1) + x2
      x11 = co(0)*m*w2(3)
      x12 = w1(0) - w1(3)
      x13 = co(0)*m*w2(2)
      x14 = pl(3)*w1(0)
      x15 = pl(3)*w1(3)
      x16 = pl(0)*w1(1)
      x17 = pl(0)*x2
      x18 = pl(0)*w1(3)
      x19 = pl(0)*w1(0)
      x20 = pl(3)*w1(1) + pl(3)*x2
      x21 = -w1(1) + x2
      x22 = w1(0) + w1(3)
      x23 = co(0)*w2(3)
      x24 = co(0)*w2(2)
      x25 = co(1)*m*w2(0)
      x26 = co(1)*m*w2(1)
      wout(0) = x10*x11 - x12*x13 - x4*(x0 + x1 + x3) - x9*(x5 + x6 + x7 + x8)
      wout(1) = -x11*x22 - x13*x21 + x4*(x14 + x15 - x16 + x17) + x9*(x18 - x19&
                 + x20)
      wout(2) = -x10*x26 - x22*x25 + x23*(x16 + x17 - x6 + x7) - x24*(-x18 +   &
                x19 + x3)
      wout(3) = -x12*x26 + x21*x25 + x23*(-x0 - x1 + x20) - x24*(x14 - x15 - x5&
                 + x8)
    else
      x0 = cima*w1(2)
      x1 = w1(1) + x0
      x2 = w1(0) - w1(3)
      x3 = -w1(1) + x0
      x4 = w1(0) + w1(3)
      wout(0) = co(0)*(-w2(2)*x2 + w2(3)*x1)
      wout(1) = -co(0)*(w2(2)*x3 + w2(3)*x4)
      wout(2) = -co(1)*(w2(0)*x4 + w2(1)*x1)
      wout(3) = co(1)*(w2(0)*x3 - w2(1)*x2)
    end if 
      end select 
    end subroutine treeVFaF0
end module tcVFaF0
